# -*- coding: utf-8 -*-
'''
littlecms package for a Facade API to the low level c_lcms wrapper interfacing
to the LCMS (LittleCMS) library.

Currently support only for three channel colour spaces is given.
'''

## Created: 2009-01-17 Guy K. Kloss <G.Kloss@massey.ac.nz>
## Changed: $Id:$
##
## Copyright 2009 Guy K. Kloss
## All rights reserved.
##
## This software is distributed under the terms of the
## GNU Lesser General Public License
##
## http://www.massey.ac.nz/~gkloss/

__author__ = 'Guy K. Kloss <G.Kloss@massey.ac.nz>'
__date__ = '$Date: $'
__versioninfo__ = (0, 7, 0)
__version__ = '.'.join(map(str, __versioninfo__))

from littlecms.c_lcms import * # pylint: disable-msg=W0401, W0614
from littlecms.general import * # pylint: disable-msg=W0401, W0614
from littlecms.profile import * # pylint: disable-msg=W0401, W0614
from littlecms.tag import * # pylint: disable-msg=W0401, W0614
from littlecms.transform import * # pylint: disable-msg=W0401, W0614
from littlecms.support_structures import * # pylint: disable-msg=W0401, W0614
from littlecms import read_tags


__all__ = filter(lambda s: not s.startswith('_'), dir())
__all__.extend(['__author__', '__date__', '__versioninfo__', '__version__'])
