import sys
import traceback
from os import getenv, listdir
from os.path import join
from ctypes import *
from ctypes.util import find_library

STRING = c_char_p

def find_wand(path):
    try:
        return find_library(path)
    except:
        pass

# Mac OS user may have installed ImageMagick via Fink
wand_lib = None
wand_path = ['MagickWand', 'Wand', '/usr/local/lib/libWand', '/sw/lib/libWand', '/opt/local/lib/libWand']
if sys.platform.startswith('win'):
    wand_path.insert(0, 'ImageMagick\CORE_RL_wand_')
    for item in listdir(getenv('programfiles')):
        if 'ImageMagick' in item:
            wand_path.insert(0, join(getenv('programfiles'), item, 'CORE_RL_wand_'))
            break
  
for path in wand_path:
    wand_lib = find_library(path)
    if wand_lib:
        break

if not wand_lib:
    import os.path
    if os.path.isfile('ImageMagick\CORE_RL_wand_.dll'):
        wand_lib = 'Imagemagick\CORE_RL_wand_.dll'
    else:
        raise ImportError('Cannot find ImageMagick MagickWand library.')

_lib = CDLL(wand_lib)

WSTRING = c_wchar_p

def version():
    try:
	GetMagickVersion = _lib.GetMagickVersion
	GetMagickVersion.restype = STRING
	GetMagickVersion.argtypes = [POINTER(c_ulong)]
	PI = POINTER(c_ulong)
	PI = c_ulong()
	return GetMagickVersion(PI)
    except:
        return None

BesselFilter = 14
CompareAnyLayer = 2
OverlayCompositeOp = 41
X11Event = 32768
MagickQuantumFormatOptions = 37
AllValues = 2147483647
OpacityQuantum = 13
UndefinedTransmitType = 0
CMYKColorspace = 12
LosslessJPEGCompression = 7
__GCONV_NOCONV = 1
ActivateAlphaChannel = 1
MagickStorageOptions = 40
DstInCompositeOp = 23
RoundJoin = 2
RollPreview = 3
OpacityChannel = 8
TopLeftOrientation = 1
LongPixel = 5
MaxEvaluateOperator = 5
UndefinedDistortion = 0
__GCONV_NOMEM = 3
LeftBottomOrientation = 8
UndefinedQuantumFormat = 0
NonZeroRule = 2
__GCONV_FULL_OUTPUT = 5
BicubicInterpolatePixel = 2
QuadraticFilter = 9
DiskResource = 2
MagickVirtualPixelOptions = 44
UndefinedColorspace = 0
StreamFatalError = 740
IndexAlphaQuantum = 10
ReplaceCompositeOp = 43
ChangeMaskCompositeOp = 6
OHTAColorspace = 4
HeightValue = 8
ImageFatalError = 765
LabColorspace = 5
UltraExpandedStretch = 9
EdgeVirtualPixelMethod = 4
NormalStretch = 1
ShortPixel = 7
SetAlphaChannel = 4
ArcDistortion = 10
PolarDistortion = 11
DePolarDistortion = 12
BarrelDistortion = 13
BarrelInverseDistortion = 14
ShepardsDistortion = 15
SentinelDistortion = 16
AffineProjectionDistortion = 2
ScaleRotateTranslateDistortion = 3	
__codecvt_partial = 1
MultiplicativeGaussianNoise = 3
UndefinedSpread = 0
EncoderThreadSupport = 2
UndefinedStretch = 0
DstAtopCompositeOp = 21
TypeFatalError = 705
WarningException = 300
MagickImageFilterModule = 1
MinEvaluateOperator = 6
TrueColorType = 6
UndefinedTimerState = 0
MagickDelegateOptions = 48
UndefinedGravity = 0
SaturationIntent = 1
OptimizePlusLayer = 8
RoundRectanglePrimitive = 4
OptionFatalError = 710
ResourceLimitWarning = 300
ConcatenateMode = 3
MagickMetricOptions = 29
FileTransmitType = 1
MagentaQuantum = 12
ScreenCompositeOp = 45
UndefinedClass = 0
UndefinedRule = 0
UserEvent = 8192
SemiExpandedStretch = 6
UndefinedPixel = 0
HWBColorspace = 16
EvenOddRule = 1
UndefinedJoin = 0
AnnotateEvent = 2
TailPath = 4
PixelsPerCentimeterResolution = 2
AnyStretch = 10
ImpulseNoise = 4
MagickComposeOptions = 8
TopRightOrientation = 2
IntegerPixel = 4
MagickMimeOptions = 51
GrayscaleMatteType = 3
ImplodePreview = 25
CopyGreenCompositeOp = 15
PathPrimitive = 15
PeakSignalToNoiseRatioMetric = 6
UndefinedCompliance = 0
TriangleFilter = 3
LineInterlace = 2
GaussianFilter = 8
StaticGravity = 10
ShadePreview = 21
MosaicLayer = 15
CMYKAQuantum = 4
UndefinedPrimitive = 0
FilterInterpolatePixel = 4
PolygonPrimitive = 9
RGBAQuantum = 15
ResourceEvent = 2048
FloatingPointQuantumFormat = 1
MagickLineJoinOptions = 26
DisposeLayer = 5
RedQuantum = 14
MissingDelegateWarning = 320
XServerError = 480
CopyCyanCompositeOp = 14
MagickChannelOptions = 3
Rec601YCbCrColorspace = 18
JPEGCompression = 5
MultiplyEvaluateOperator = 7
DefaultChannels = 247
BlobError = 435
ForgetGravity = 0
__codecvt_ok = 0
SquareCap = 3
SubimagePath = 7
MagickPreviewOptions = 35
RandomNoise = 7
__codecvt_error = 2
UndefinedChannel = 0
MeanSquaredErrorMetric = 4
UndefinedInterpolatePixel = 0
CubicFilter = 10
CorruptImageFatalError = 725
RemoveDupsLayer = 10
ObliqueStyle = 3
MagickResourceOptions = 39
CatromFilter = 11
CompareClearLayer = 3
ResetMethod = 5
UniformNoise = 1
UndefinedOrientation = 0
RGBOQuantum = 16
SrcInCompositeOp = 49
ExceptionEvent = 256
MagickLayerOptions = 24
FileResource = 3
FloatPixel = 3
UndefinedQuantum = 0
EastGravity = 6
UndefinedResolution = 0
DullPreview = 9
OverlineDecoration = 3
CoderWarning = 350
MagickDisposeOptions = 13
Rec709YCbCrColorspace = 20
ConstantVirtualPixelMethod = 2
DstOutCompositeOp = 24
SetEvaluateOperator = 10
AbsoluteIntent = 3
AddNoisePreview = 14
DitherVirtualPixelMethod = 3
ParzenFilter = 18
AllCompliance = 2147483647
MagickLocaleOptions = 52
HuePreview = 4
HardLightCompositeOp = 30
__GCONV_EMPTY_INPUT = 4
BlobTransmitType = 2
ImageInfoRegistryType = 2
UndefinedInterlace = 0
LSBEndian = 1
ItalicStyle = 2
UserSpace = 1
BlendCompositeOp = 4
GrayAlphaQuantum = 7
__GCONV_IS_LAST = 1
FlattenLayer = 14
PNGInterlace = 7
DirectClass = 1
XValue = 1
MagickMethodOptions = 30
BoxFilter = 2
PercentValue = 4096
AreaResource = 1
WidthValue = 4
UndefinedEvents = 0
DeactivateAlphaChannel = 2
UltraCondensedStretch = 2
ModuleError = 455
CacheWarning = 345
XNegative = 32
UnsignedQuantumFormat = 3
MagickInterpolateOptions = 23
YIQColorspace = 9
YellowQuantum = 18
SrcOverCompositeOp = 51
DoublePixel = 2
WavePreview = 26
RedChannel = 1
MagickClassOptions = 4
ExclusionCompositeOp = 29
GaussianNoise = 2
ReadMode = 0
QuantumPixel = 6
MonitorError = 485
PointPrimitive = 1
MagickDecorateOptions = 12
CMYColorspace = 22
CopyRedCompositeOp = 18
XorEvaluateOperator = 12
LeftAlign = 1
UndefinedIntent = 0
MinusCompositeOp = 36
MagickLogOptions = 53
MatteChannel = 8
AverageInterpolatePixel = 1
AddCompositeOp = 2
__GCONV_OK = 0
BlurPreview = 16
CyanChannel = 1
PeakAbsoluteErrorMetric = 5
TrueColorMatteType = 7
AndEvaluateOperator = 2
FileOpenFatalError = 730
HeadPath = 3
InCompositeOp = 32
HanningFilter = 5
AlphaQuantum = 1
PlaneInterlace = 3
MagickNoiseOptions = 33
SincFilter = 15
CyanQuantum = 6
DifferenceCompositeOp = 26
MagickStyleOptions = 42
YValue = 2
DrawEvent = 128
MagickMogrifyOptions = 32
LessValue = 16384
ColorPrimitive = 11
UndefinedMagickLayerMethod = 0
RaisePreview = 22
ChiValue = 16
NoCompression = 1
BartlettFilter = 21
CenterGravity = 5
ColorBurnCompositeOp = 8
JPEG2000Compression = 6
ModuleFatalError = 755
ThresholdCompositeOp = 53
UndefinedCap = 0
NoInterlace = 1
MissingDelegateFatalError = 720
SplineInterpolatePixel = 8
MagickThresholdOptions = 56
MaskVirtualPixelMethod = 9
YellowChannel = 4
DecoderThreadSupport = 1
LaplacianNoise = 5
ImagePrimitive = 14
MagickTrue = 1
AreaValue = 131072
UndefinedRegistryType = 0
MagickResolutionOptions = 38
RelativeIntent = 4
CopyBlueCompositeOp = 12
LinearLightCompositeOp = 34
EllipsePrimitive = 6
BilinearInterpolatePixel = 3
MergeLayer = 13
PointMethod = 1
SouthWestGravity = 7
UnrecognizedDispose = 0
PolylinePrimitive = 8
GreenQuantum = 9
DissolveCompositeOp = 28
__GCONV_INCOMPLETE_INPUT = 7
TransparentColorspace = 3
MinimumValue = 65536
TextPrimitive = 13
WandFatalError = 770
WandError = 470
RLECompression = 9
XServerFatalError = 780
DivideCompositeOp = 55
AddEvaluateOperator = 1
PaletteBilevelMatteType = 11
MagickDataTypeOptions = 10
SouthGravity = 8
ThresholdPreview = 17
ClearCompositeOp = 7
AllChannels = 255
LuminizeCompositeOp = 35
NoCompositeOp = 1
QuantizePreview = 11
OptionError = 410
ColorSeparationType = 8
MeanErrorPerPixelMetric = 3
OptimizeTransLayer = 9
WandEvent = 16384
MagickIntentOptions = 21
UndefinedMode = 0
ObjectBoundingBox = 3
UndefinedPreview = 0
KaiserFilter = 16
PartitionInterlace = 4
BohmanFilter = 20
DecimalValue = 262144
PreviousDispose = 3
MagickEvaluateOptions = 16
MemoryResource = 5
YUVColorspace = 11
YNegative = 64
MagickFillRuleOptions = 17
MagickPath = 1
ExtraExpandedStretch = 8
RegistryError = 490
ScaleRotateTranslateDistortion = 3
MiterJoin = 1
BrightnessPreview = 6
SharpenPreview = 15
MagickUndefinedOptions = -1
ColorDodgeCompositeOp = 9
BasePath = 5
RightAlign = 3
MagickAlignOptions = 0
ExtensionPath = 6
CacheError = 445
UndefinedFilter = 0
StreamError = 440
CanonicalPath = 8
BackgroundDispose = 2
ResourceLimitFatalError = 700
StoppedTimerState = 1
NoValue = 0
LeftShiftEvaluateOperator = 4
SentinelFilter = 22
BlueQuantum = 3
PoissonNoise = 6
MagentaChannel = 2
PlusCompositeOp = 42
SwirlPreview = 24
MagickListOptions = 27
BackgroundVirtualPixelMethod = 1
YCCColorspace = 8
MonitorFatalError = 785
MitchellFilter = 12
DelegateWarning = 315
sRGBColorspace = 13
PseudoClass = 2
RegistryWarning = 390
CoderEvent = 16
MagickCompressOptions = 9
UndefinedPath = 0
EdgeDetectPreview = 18
DrawWarning = 360
GrayChannel = 1
MagickDebugOptions = 11
BilinearDistortion = 7
BilinearReverseDistortion = 8
PolynomialDistortion = 9
PolynomialFunction = 1
OptimizeLayer = 6
WandWarning = 370
MagickModuleOptions = 55
RunningTimerState = 2
CompositeLayer = 12
FatalErrorException = 700
ModuleWarning = 355
BlackChannel = 32
XPMCompliance = 4
OptionWarning = 310
AbsoluteErrorMetric = 1
DelegateError = 415
CorruptImageWarning = 325
Group4Compression = 4
JPEGInterlace = 6
MagickColorOptions = 46
__GCONV_ILLEGAL_DESCRIPTOR = 8
RightTopOrientation = 6
PerceptualIntent = 2
LagrangeFilter = 19
WestGravity = 4
UndefinedType = 0
UnderlineDecoration = 2
AnyStyle = 4
FaxCompression = 3
CacheFatalError = 745
CoderError = 450
ColorSeparationMatteType = 9
IOMode = 2
BumpmapCompositeOp = 5
CacheEvent = 8
DrawFatalError = 760
IndexQuantum = 11
SaturateCompositeOp = 44
SignedQuantumFormat = 2
MeanAbsoluteErrorMetric = 2
RepeatSpread = 3
RegistryFatalError = 790
BottomRightOrientation = 3
NoDecoration = 1
ConfigureWarning = 395
UndefinedNoise = 0
MagickFilterOptions = 18
HSLColorspace = 15
RadialGradient = 2
MagickConfigureOptions = 47
GreenChannel = 2
MagickEndianOptions = 15
PerspectiveProjectionDistortion = 5
BilinearForwardDistortion = 6
PixelsPerInchResolution = 1
RightShiftEvaluateOperator = 9
RectanglePrimitive = 3
AlphaChannel = 8
MagickPrimitiveOptions = 36
MagickLogEventOptions = 28
ImageRegistryType = 1
ButtCap = 1
BlackmanFilter = 7
PointFilter = 1
GrayVirtualPixelMethod = 11
AtopCompositeOp = 3
__GCONV_IGNORE_ERRORS = 2
CompareOverlayLayer = 4
GrayQuantum = 8
MagickStretchOptions = 41
StreamWarning = 340
ColorizeCompositeOp = 10
TypeWarning = 305
SoftLightCompositeOp = 46
StreamTransmitType = 3
MagickFalse = 0
LightenCompositeOp = 33
ErrorException = 400
XorCompositeOp = 54
MagickColorspaceOptions = 6
Rec601LumaColorspace = 17
PerspectiveDistortion = 4
BevelJoin = 3
ConfigureFatalError = 795
ArcPrimitive = 5
CorruptImageError = 425
BottomLeftOrientation = 4
BlackVirtualPixelMethod = 10
CopyBlackCompositeOp = 11
TransformEvent = 4096
SpreadPreview = 19
TileVirtualPixelMethod = 7
__GCONV_ILLEGAL_INPUT = 6
SrcCompositeOp = 48
CMYKQuantum = 5
FileOpenWarning = 330
DstCompositeOp = 22
ModuleEvent = 1024
MagickImageCoderModule = 0
PaletteType = 4
SrcAtopCompositeOp = 47
CondensedStretch = 4
RightBottomOrientation = 7
MagickFontsOptions = 19
HSBColorspace = 14
ResetAlphaChannel = 3
Rec709LumaColorspace = 19
ReduceNoisePreview = 13
ReflectSpread = 2
CopyMagentaCompositeOp = 16
SpiffPreview = 8
NormalStyle = 1
ShearPreview = 2
MagickClipPathOptions = 5
__GCONV_INTERNAL_ERROR = 9
UndefinedCompositeOp = 0
IndexChannel = 32
ChiNegative = 128
CirclePrimitive = 7
UndefinedLayer = 0
UndefinedDecoration = 0
DrawError = 460
RhoValue = 4
GRAYColorspace = 2
UndefinedReference = 0
WriteMode = 1
XiValue = 2
XiNegative = 32
MirrorVirtualPixelMethod = 5
UndefinedStyle = 0
RGBQuantum = 17
SrcOutCompositeOp = 50
MagickModeOptions = 31
OilPaintPreview = 27
TraceEvent = 1
SubtractCompositeOp = 52
LogColorspace = 21
SubtractEvaluateOperator = 11
ResourceLimitError = 400
FileOpenError = 430
NoneDispose = 1
LeftTopOrientation = 5
RoundCap = 2
PaletteMatteType = 5
RotatePreview = 1
GrayscalePreview = 10
NoCompliance = 0
HueCompositeOp = 31
MagickCoderOptions = 45
UndefinedEndian = 0
CharPixel = 1
GrayscaleType = 2
HermiteFilter = 4
CoderFatalError = 750
StringRegistryType = 3
CopyYellowCompositeOp = 19
MSBEndian = 2
UserSpaceOnUse = 2
WelshFilter = 17
ImageError = 465
RandomVirtualPixelMethod = 6
AspectValue = 8192
BezierPrimitive = 10
ExtraCondensedStretch = 3
XYZColorspace = 6
UndefinedException = 0
MonitorWarning = 385
UndefinedMetric = 0
PsiNegative = 64
JPEGPreview = 29
MagickInterlaceOptions = 22
CopyOpacityCompositeOp = 17
ExpandedStretch = 7
OrEvaluateOperator = 8
SegmentPreview = 23
OutCompositeOp = 39
MagickCommandOptions = 7
NoEvents = 0
UndefinedGradient = 0
MagickBooleanOptions = 2
ReplaceMethod = 2
CenterAlign = 2
MeshInterpolatePixel = 6
MultiplyCompositeOp = 38
MagickAlphaOptions = 1
__codecvt_noconv = 3
SVGCompliance = 1
BlobFatalError = 735
MagickFormatOptions = 50
TypeError = 405
ConfigureEvent = 32
GammaPreview = 7
LocaleEvent = 512
NorthWestGravity = 1
CopyCompositeOp = 13
UndefinedAlign = 0
UndefinedEvaluateOperator = 0
ModulateCompositeOp = 37
DelegateFatalError = 715
DivideEvaluateOperator = 3
RemoveZeroLayer = 11
BlackQuantum = 2
BlueChannel = 4
PsiValue = 1
LanczosFilter = 13
CoalesceLayer = 1
DisplaceCompositeOp = 27
GIFInterlace = 5
MapResource = 4
GreaterValue = 32768
UndefinedCompression = 0
MattePrimitive = 12
XServerWarning = 380
MagickLineCapOptions = 25
YCbCrColorspace = 7
BZipCompression = 2
MagickDistortOptions = 14
DeprecateEvent = 64
SemiCondensedStretch = 5
WhiteVirtualPixelMethod = 12
CharcoalDrawingPreview = 28
ImageTransmitType = 4
RGBColorspace = 1
BlobWarning = 335
UndefinedVirtualPixelMethod = 0
BlobEvent = 4
LineThroughDecoration = 4
SolarizePreview = 20
PadSpread = 1
DarkenCompositeOp = 20
RootPath = 2
NearestNeighborInterpolatePixel = 7
UndefinedMethod = 0
LZWCompression = 8
BilevelType = 1
SaturationPreview = 5
__GCONV_NODB = 2
FillToBorderMethod = 4
RootMeanSquaredErrorMetric = 7
UndefinedResource = 0
NorthGravity = 2
FloodfillMethod = 3
MagickOrientationOptions = 34
X11Compliance = 2
AllEvents = 2147483647
MagickTypeOptions = 43
FrameMode = 1
NorthEastGravity = 3
UndefinedPathUnits = 0
SigmaValue = 8
UndefinedAlphaChannel = 0
GradientReference = 1
MissingDelegateError = 420
YPbPrColorspace = 10
MagickGravityOptions = 20
LinearGradient = 1
DespecklePreview = 12
ConfigureError = 495
DstOverCompositeOp = 25
AffineDistortion = 1
LinePrimitive = 2
UnframeMode = 2
MagickMagicOptions = 54
TransparentVirtualPixelMethod = 8
NoThreadSupport = 0
OverCompositeOp = 40
OptimizeType = 10
UndefinedDispose = 0
MagickFontOptions = 49
ZipCompression = 10
SouthEastGravity = 9
IntegerInterpolatePixel = 5
ImageWarning = 365
HammingFilter = 6
OptimizeImageLayer = 7

DefaultPathMode = 0  
AbsolutePathMode =1  
RelativePathMode =2

PathDefaultOperation = 0  
PathCloseOperation = 1  
PathCurveToOperation = 2  
PathCurveToQuadraticBezierOperation = 3  
PathCurveToQuadraticBezierSmoothOperation = 4  
PathCurveToSmoothOperation = 5  
PathEllipticArcOperation = 6 
PathLineToHorizontalOperation = 7  
PathLineToOperation = 8  
PathLineToVerticalOperation = 9  
PathMoveToOperation = 10 



# values for enumeration 'MagickBooleanType'
MagickBooleanType = c_int # enum
class _ImageInfo(Structure):
    pass
ImageInfo = _ImageInfo
class _Image(Structure):
    pass
Image = _Image

class _DrawInfo(Structure):
    pass
DrawInfo = _DrawInfo

class _TypeMetric(Structure):
    pass
TypeMetric = _TypeMetric

# values for enumeration 'MapMode'
MapMode = c_int # enum
class _IO_FILE(Structure):
    pass
FILE = _IO_FILE
size_t = c_uint
class _ExceptionInfo(Structure):
    pass
ExceptionInfo = _ExceptionInfo
MagickSizeType = c_ulonglong
StreamHandler = CFUNCTYPE(size_t, POINTER(Image), c_void_p, size_t)

# values for enumeration 'VirtualPixelMethod'
VirtualPixelMethod = c_int # enum
class _ViewInfo(Structure):
    pass
_ViewInfo._fields_ = [
]
ViewInfo = _ViewInfo
Quantum = c_ushort
IndexPacket = Quantum

class _PixelPacket(Structure):
    pass
PixelPacket = _PixelPacket
MagickOffsetType = c_longlong

class _CoderInfo(Structure):
    pass
_CoderInfo._fields_ = [
    ('path', STRING),
    ('magick', STRING),
    ('name', STRING),
    ('stealth', MagickBooleanType),
    ('previous', POINTER(_CoderInfo)),
    ('next', POINTER(_CoderInfo)),
    ('signature', c_ulong),
]

# values for enumeration 'ComplianceType'
ComplianceType = c_int # enum
class _ColorInfo(Structure):
    pass
class _MagickPixelPacket(Structure):
    pass

# values for enumeration 'ClassType'
ClassType = c_int # enum

# values for enumeration 'ColorspaceType'
ColorspaceType = c_int # enum
MagickRealType = c_double
_MagickPixelPacket._pack_ = 4
_MagickPixelPacket._fields_ = [
    ('storage_class', ClassType),
    ('colorspace', ColorspaceType),
    ('matte', MagickBooleanType),
    ('fuzz', c_double),
    ('depth', c_ulong),
    ('red', MagickRealType),
    ('green', MagickRealType),
    ('blue', MagickRealType),
    ('opacity', MagickRealType),
    ('index', MagickRealType),
]
MagickPixelPacket = _MagickPixelPacket
_ColorInfo._fields_ = [
    ('path', STRING),
    ('name', STRING),
    ('compliance', ComplianceType),
    ('color', MagickPixelPacket),
    ('stealth', MagickBooleanType),
    ('previous', POINTER(_ColorInfo)),
    ('next', POINTER(_ColorInfo)),
    ('signature', c_ulong),
]
ColorInfo = _ColorInfo
class _ColorPacket(Structure):
    pass
_PixelPacket._fields_ = [
    ('blue', Quantum),
    ('green', Quantum),
    ('red', Quantum),
    ('opacity', Quantum),
]
_ColorPacket._pack_ = 4
_ColorPacket._fields_ = [
    ('pixel', PixelPacket),
    ('index', IndexPacket),
    ('count', MagickSizeType),
]
ColorPacket = _ColorPacket
class _ErrorInfo(Structure):
    pass
_ErrorInfo._pack_ = 4
_ErrorInfo._fields_ = [
    ('mean_error_per_pixel', c_double),
    ('normalized_mean_error', c_double),
    ('normalized_maximum_error', c_double),
]
ErrorInfo = _ErrorInfo

# values for enumeration 'MetricType'
MetricType = c_int # enum

# values for enumeration 'ChannelType'
ChannelType = c_int # enum

# values for enumeration 'CompositeOperator'
CompositeOperator = c_int # enum

# values for enumeration 'CompressionType'
CompressionType = c_int # enum
class _Ascii85Info(Structure):
    pass
_Ascii85Info._fields_ = [
]
Ascii85Info = _Ascii85Info

class _ConfigureInfo(Structure):
    pass
_ConfigureInfo._fields_ = [
    ('path', STRING),
    ('name', STRING),
    ('value', STRING),
    ('stealth', MagickBooleanType),
    ('previous', POINTER(_ConfigureInfo)),
    ('next', POINTER(_ConfigureInfo)),
    ('signature', c_ulong),
]
ConfigureInfo = _ConfigureInfo

class _LinkedListInfo(Structure):
    pass
LinkedListInfo = _LinkedListInfo

# values for enumeration 'StorageType'
StorageType = c_int # enum

class _FrameInfo(Structure):
    pass
_FrameInfo._fields_ = [
    ('width', c_ulong),
    ('height', c_ulong),
    ('x', c_long),
    ('y', c_long),
    ('inner_bevel', c_long),
    ('outer_bevel', c_long),
]
FrameInfo = _FrameInfo
class _RectangleInfo(Structure):
    pass
RectangleInfo = _RectangleInfo

class _DelegateInfo(Structure):
    pass
_DelegateInfo._fields_ = [
    ('path', STRING),
    ('decode', STRING),
    ('encode', STRING),
    ('commands', STRING),
    ('mode', c_long),
    ('thread_support', MagickBooleanType),
    ('spawn', MagickBooleanType),
    ('stealth', MagickBooleanType),
    ('previous', POINTER(_DelegateInfo)),
    ('next', POINTER(_DelegateInfo)),
    ('signature', c_ulong),
]
DelegateInfo = _DelegateInfo

class _DoublePixelPacket(Structure):
    pass
_DoublePixelPacket._pack_ = 4
_DoublePixelPacket._fields_ = [
    ('red', c_double),
    ('green', c_double),
    ('blue', c_double),
    ('opacity', c_double),
    ('index', c_double),
]
DoublePixelPacket = _DoublePixelPacket

# values for enumeration 'MagickLayerMethod'
MagickLayerMethod = c_int # enum
ExtendedSignedIntegralType = c_longlong
ExtendedUnsignedIntegralType = c_ulonglong
MonitorHandler = CFUNCTYPE(MagickBooleanType, STRING, MagickOffsetType, MagickSizeType, POINTER(ExceptionInfo))
class _ImageAttribute(Structure):
    pass
_ImageAttribute._fields_ = [
    ('key', STRING),
    ('value', STRING),
    ('compression', MagickBooleanType),
    ('previous', POINTER(_ImageAttribute)),
    ('next', POINTER(_ImageAttribute)),
]
ImageAttribute = _ImageAttribute

# values for enumeration 'RegistryType'
RegistryType = c_int # enum

# values for enumeration 'PaintMethod'
PaintMethod = c_int # enum
__gnuc_va_list = STRING
va_list = __gnuc_va_list

# values for enumeration 'QuantumType'
QuantumType = c_int # enum

# values for enumeration 'ExceptionType'
ExceptionType = c_int # enum

class _AffineMatrix(Structure):
    pass
AffineMatrix = _AffineMatrix

class SemaphoreInfo(Structure):
    pass

# values for enumeration 'DistortImageMethod'
DistortImageMethod = c_int # enum

# values for enumeration 'MagickFunction'
MagickFunction = c_int # enum

# values for enumeration 'AlignType'
AlignType = c_int # enum

# values for enumeration 'ClipPathUnits'
ClipPathUnits = c_int # enum

# values for enumeration 'DecorationType'
DecorationType = c_int # enum

# values for enumeration 'FillRule'
FillRule = c_int # enum

# values for enumeration 'GradientType'
GradientType = c_int # enum

# values for enumeration 'LineCap'
LineCap = c_int # enum

# values for enumeration 'LineJoin'
LineJoin = c_int # enum

# values for enumeration 'PrimitiveType'
PrimitiveType = c_int # enum

# values for enumeration 'ReferenceType'
ReferenceType = c_int # enum

# values for enumeration 'SpreadMethod'
SpreadMethod = c_int # enum
class _StopInfo(Structure):
    pass
_StopInfo._pack_ = 4
_StopInfo._fields_ = [
    ('color', MagickPixelPacket),
    ('offset', MagickRealType),
]
StopInfo = _StopInfo
class _GradientInfo(Structure):
    pass
_RectangleInfo._fields_ = [
    ('width', c_ulong),
    ('height', c_ulong),
    ('x', c_long),
    ('y', c_long),
]
class _SegmentInfo(Structure):
    pass
_SegmentInfo._pack_ = 4
_SegmentInfo._fields_ = [
    ('x1', c_double),
    ('y1', c_double),
    ('x2', c_double),
    ('y2', c_double),
]
SegmentInfo = _SegmentInfo
_GradientInfo._fields_ = [
    ('type', GradientType),
    ('bounding_box', RectangleInfo),
    ('gradient_vector', SegmentInfo),
    ('stops', POINTER(StopInfo)),
    ('number_stops', c_ulong),
    ('spread', SpreadMethod),
    ('debug', MagickBooleanType),
    ('signature', c_ulong),
]
GradientInfo = _GradientInfo
class _ElementReference(Structure):
    pass
_ElementReference._fields_ = [
    ('id', STRING),
    ('type', ReferenceType),
    ('gradient', GradientInfo),
    ('signature', c_ulong),
    ('previous', POINTER(_ElementReference)),
    ('next', POINTER(_ElementReference)),
]
ElementReference = _ElementReference
_AffineMatrix._pack_ = 4
_AffineMatrix._fields_ = [
    ('sx', c_double),
    ('rx', c_double),
    ('ry', c_double),
    ('sy', c_double),
    ('tx', c_double),
    ('ty', c_double),
]

# values for enumeration 'GravityType'
GravityType = c_int # enum

# values for enumeration 'StyleType'
StyleType = c_int # enum

# values for enumeration 'StretchType'
StretchType = c_int # enum
_DrawInfo._pack_ = 4
_DrawInfo._fields_ = [
    ('primitive', STRING),
    ('geometry', STRING),
    ('viewbox', RectangleInfo),
    ('affine', AffineMatrix),
    ('gravity', GravityType),
    ('fill', PixelPacket),
    ('stroke', PixelPacket),
    ('stroke_width', c_double),
    ('gradient', GradientInfo),
    ('fill_pattern', POINTER(Image)),
    ('tile', POINTER(Image)),
    ('stroke_pattern', POINTER(Image)),
    ('stroke_antialias', MagickBooleanType),
    ('text_antialias', MagickBooleanType),
    ('fill_rule', FillRule),
    ('linecap', LineCap),
    ('linejoin', LineJoin),
    ('miterlimit', c_ulong),
    ('dash_offset', c_double),
    ('decorate', DecorationType),
    ('compose', CompositeOperator),
    ('text', STRING),
    ('face', c_ulong),
    ('font', STRING),
    ('metrics', STRING),
    ('family', STRING),
    ('style', StyleType),
    ('stretch', StretchType),
    ('weight', c_ulong),
    ('encoding', STRING),
    ('pointsize', c_double),
    ('density', STRING),
    ('align', AlignType),
    ('undercolor', PixelPacket),
    ('border_color', PixelPacket),
    ('server_name', STRING),
    ('dash_pattern', POINTER(c_double)),
    ('clip_mask', STRING),
    ('bounds', SegmentInfo),
    ('clip_units', ClipPathUnits),
    ('opacity', Quantum),
    ('render', MagickBooleanType),
    ('element_reference', ElementReference),
    ('debug', MagickBooleanType),
    ('signature', c_ulong),
]
class _PointInfo(Structure):
    pass
_PointInfo._pack_ = 4
_PointInfo._fields_ = [
    ('x', c_double),
    ('y', c_double),
]
PointInfo = _PointInfo
class _PrimitiveInfo(Structure):
    pass
_PrimitiveInfo._fields_ = [
    ('point', PointInfo),
    ('coordinates', c_ulong),
    ('primitive', PrimitiveType),
    ('method', PaintMethod),
    ('text', STRING),
]
PrimitiveInfo = _PrimitiveInfo
_TypeMetric._pack_ = 4
_TypeMetric._fields_ = [
    ('pixels_per_em', PointInfo),
    ('ascent', c_double),
    ('descent', c_double),
    ('width', c_double),
    ('height', c_double),
    ('max_advance', c_double),
    ('underline_position', c_double),
    ('underline_thickness', c_double),
    ('bounds', SegmentInfo),
    ('origin', PointInfo),
]

# values for enumeration 'NoiseType'
NoiseType = c_int # enum

# values for enumeration 'PreviewType'
PreviewType = c_int # enum

_ExceptionInfo._fields_ = [
    ('severity', ExceptionType),
    ('error_number', c_int),
    ('reason', STRING),
    ('description', STRING),
    ('exceptions', c_void_p),
    ('relinquish', MagickBooleanType),
    ('semaphore', POINTER(SemaphoreInfo)),
    ('signature', c_ulong),
]
ErrorHandler = CFUNCTYPE(None, ExceptionType, STRING, STRING)
FatalErrorHandler = CFUNCTYPE(None, ExceptionType, STRING, STRING)
WarningHandler = CFUNCTYPE(None, ExceptionType, STRING, STRING)

# values for enumeration 'MagickEvaluateOperator'
MagickEvaluateOperator = c_int # enum

# values for enumeration 'GeometryFlags'
GeometryFlags = c_int # enum
class _GeometryInfo(Structure):
    pass
_GeometryInfo._pack_ = 4
_GeometryInfo._fields_ = [
    ('rho', c_double),
    ('sigma', c_double),
    ('xi', c_double),
    ('psi', c_double),
    ('chi', c_double),
]
GeometryInfo = _GeometryInfo

MagickStatusType = c_uint

class _HashmapInfo(Structure):
    pass
_HashmapInfo._fields_ = [
]
HashmapInfo = _HashmapInfo
_LinkedListInfo._fields_ = [
]

# values for enumeration 'AlphaChannelType'
AlphaChannelType = c_int # enum

# values for enumeration 'ImageType'
ImageType = c_int # enum

# values for enumeration 'InterlaceType'
InterlaceType = c_int # enum

# values for enumeration 'OrientationType'
OrientationType = c_int # enum

# values for enumeration 'ResolutionType'
ResolutionType = c_int # enum
class _PrimaryInfo(Structure):
    pass
_PrimaryInfo._pack_ = 4
_PrimaryInfo._fields_ = [
    ('x', c_double),
    ('y', c_double),
    ('z', c_double),
]
PrimaryInfo = _PrimaryInfo

# values for enumeration 'TransmitType'
TransmitType = c_int # enum
class _ChromaticityInfo(Structure):
    pass
_ChromaticityInfo._fields_ = [
    ('red_primary', PrimaryInfo),
    ('green_primary', PrimaryInfo),
    ('blue_primary', PrimaryInfo),
    ('white_point', PrimaryInfo),
]
ChromaticityInfo = _ChromaticityInfo

# values for enumeration 'RenderingIntent'
RenderingIntent = c_int # enum

# values for enumeration 'FilterTypes'
FilterTypes = c_int # enum

# values for enumeration 'EndianType'
EndianType = c_int # enum

# values for enumeration 'DisposeType'
DisposeType = c_int # enum
class _TimerInfo(Structure):
    pass
class _Timer(Structure):
    pass
_Timer._pack_ = 4
_Timer._fields_ = [
    ('start', c_double),
    ('stop', c_double),
    ('total', c_double),
]
Timer = _Timer

# values for enumeration 'TimerState'
TimerState = c_int # enum
_TimerInfo._fields_ = [
    ('user', Timer),
    ('elapsed', Timer),
    ('state', TimerState),
    ('signature', c_ulong),
]
TimerInfo = _TimerInfo
MagickProgressMonitor = CFUNCTYPE(MagickBooleanType, STRING, MagickOffsetType, MagickSizeType, c_void_p)
class _BlobInfo(Structure):
    pass
BlobInfo = _BlobInfo
class _ProfileInfo(Structure):
    pass
_ProfileInfo._fields_ = [
    ('name', STRING),
    ('length', size_t),
    ('info', POINTER(c_ubyte)),
    ('signature', c_ulong),
]
ProfileInfo = _ProfileInfo

# values for enumeration 'InterpolatePixelMethod'
InterpolatePixelMethod = c_int # enum
_Image._pack_ = 4
_Image._fields_ = [
    ('storage_class', ClassType),
    ('colorspace', ColorspaceType),
    ('compression', CompressionType),
    ('quality', c_ulong),
    ('orientation', OrientationType),
    ('taint', MagickBooleanType),
    ('matte', MagickBooleanType),
    ('columns', c_ulong),
    ('rows', c_ulong),
    ('depth', c_ulong),
    ('colors', c_ulong),
    ('colormap', POINTER(PixelPacket)),
    ('background_color', PixelPacket),
    ('border_color', PixelPacket),
    ('matte_color', PixelPacket),
    ('gamma', c_double),
    ('chromaticity', ChromaticityInfo),
    ('rendering_intent', RenderingIntent),
    ('profiles', c_void_p),
    ('units', ResolutionType),
    ('montage', STRING),
    ('directory', STRING),
    ('geometry', STRING),
    ('offset', c_long),
    ('x_resolution', c_double),
    ('y_resolution', c_double),
    ('page', RectangleInfo),
    ('extract_info', RectangleInfo),
    ('tile_info', RectangleInfo),
    ('bias', c_double),
    ('blur', c_double),
    ('fuzz', c_double),
    ('filter', FilterTypes),
    ('interlace', InterlaceType),
    ('endian', EndianType),
    ('gravity', GravityType),
    ('compose', CompositeOperator),
    ('dispose', DisposeType),
    ('clip_mask', POINTER(_Image)),
    ('scene', c_ulong),
    ('delay', c_ulong),
    ('ticks_per_second', c_long),
    ('iterations', c_ulong),
    ('total_colors', c_ulong),
    ('start_loop', c_long),
    ('error', ErrorInfo),
    ('timer', TimerInfo),
    ('progress_monitor', MagickProgressMonitor),
    ('client_data', c_void_p),
    ('cache', c_void_p),
    ('attributes', c_void_p),
    ('ascii85', POINTER(Ascii85Info)),
    ('blob', POINTER(BlobInfo)),
    ('filename', c_char * 4096),
    ('magick_filename', c_char * 4096),
    ('magick', c_char * 4096),
    ('magick_columns', c_ulong),
    ('magick_rows', c_ulong),
    ('exception', ExceptionInfo),
    ('debug', MagickBooleanType),
    ('reference_count', c_long),
    ('semaphore', POINTER(SemaphoreInfo)),
    ('color_profile', ProfileInfo),
    ('iptc_profile', ProfileInfo),
    ('generic_profile', POINTER(ProfileInfo)),
    ('generic_profiles', c_ulong),
    ('signature', c_ulong),
    ('previous', POINTER(_Image)),
    ('list', POINTER(_Image)),
    ('next', POINTER(_Image)),
    ('interpolate', InterpolatePixelMethod),
    ('black_point_compensation', MagickBooleanType),
    ('transparent_color', PixelPacket),
    ('mask', POINTER(_Image)),
    ('tile_offset', RectangleInfo),
    ('properties', c_void_p),
    ('artifacts', c_void_p),
]
_ImageInfo._pack_ = 4
_ImageInfo._fields_ = [
    ('compression', CompressionType),
    ('orientation', OrientationType),
    ('temporary', MagickBooleanType),
    ('adjoin', MagickBooleanType),
    ('affirm', MagickBooleanType),
    ('antialias', MagickBooleanType),
    ('size', STRING),
    ('extract', STRING),
    ('page', STRING),
    ('scenes', STRING),
    ('scene', c_ulong),
    ('number_scenes', c_ulong),
    ('depth', c_ulong),
    ('interlace', InterlaceType),
    ('endian', EndianType),
    ('units', ResolutionType),
    ('quality', c_ulong),
    ('sampling_factor', STRING),
    ('server_name', STRING),
    ('font', STRING),
    ('texture', STRING),
    ('density', STRING),
    ('pointsize', c_double),
    ('fuzz', c_double),
    ('background_color', PixelPacket),
    ('border_color', PixelPacket),
    ('matte_color', PixelPacket),
    ('dither', MagickBooleanType),
    ('monochrome', MagickBooleanType),
    ('colors', c_ulong),
    ('colorspace', ColorspaceType),
    ('type', ImageType),
    ('preview_type', PreviewType),
    ('group', c_long),
    ('ping', MagickBooleanType),
    ('verbose', MagickBooleanType),
    ('view', STRING),
    ('authenticate', STRING),
    ('channel', ChannelType),
    ('attributes', POINTER(Image)),
    ('options', c_void_p),
    ('progress_monitor', MagickProgressMonitor),
    ('client_data', c_void_p),
    ('cache', c_void_p),
    ('stream', StreamHandler),
    ('file', POINTER(FILE)),
    ('blob', c_void_p),
    ('length', size_t),
    ('magick', c_char * 4096),
    ('unique', c_char * 4096),
    ('zero', c_char * 4096),
    ('filename', c_char * 4096),
    ('debug', MagickBooleanType),
    ('tile', STRING),
    ('subimage', c_ulong),
    ('subrange', c_ulong),
    ('pen', PixelPacket),
    ('signature', c_ulong),
    ('virtual_pixel_method', VirtualPixelMethod),
    ('transparent_color', PixelPacket),
    ('profile', c_void_p),
]

# values for enumeration 'ImageLayerMethod'
ImageLayerMethod = c_int # enum

class _LocaleInfo(Structure):
    pass
_LocaleInfo._fields_ = [
    ('path', STRING),
    ('tag', STRING),
    ('message', STRING),
    ('stealth', MagickBooleanType),
    ('previous', POINTER(_LocaleInfo)),
    ('next', POINTER(_LocaleInfo)),
    ('signature', c_ulong),
]
LocaleInfo = _LocaleInfo

# values for enumeration 'LogEventType'
LogEventType = c_int # enum
class _LogInfo(Structure):
    pass
_LogInfo._fields_ = [
]
LogInfo = _LogInfo

class _MagicInfo(Structure):
    pass
_MagicInfo._pack_ = 4
_MagicInfo._fields_ = [
    ('path', STRING),
    ('name', STRING),
    ('target', STRING),
    ('magic', POINTER(c_ubyte)),
    ('length', size_t),
    ('offset', MagickOffsetType),
    ('stealth', MagickBooleanType),
    ('previous', POINTER(_MagicInfo)),
    ('next', POINTER(_MagicInfo)),
    ('signature', c_ulong),
]
MagicInfo = _MagicInfo
QuantumAny = c_ulong
_BlobInfo._fields_ = [
]

# values for enumeration 'MagickThreadSupport'
MagickThreadSupport = c_int # enum
DecodeImageHandler = CFUNCTYPE(POINTER(Image), POINTER(ImageInfo), POINTER(ExceptionInfo))
EncodeImageHandler = CFUNCTYPE(MagickBooleanType, POINTER(ImageInfo), POINTER(Image))
IsImageFormatHandler = CFUNCTYPE(MagickBooleanType, POINTER(c_ubyte), size_t)
class _MagickInfo(Structure):
    pass
_MagickInfo._fields_ = [
    ('name', STRING),
    ('description', STRING),
    ('version', STRING),
    ('note', STRING),
    ('module', STRING),
    ('image_info', POINTER(ImageInfo)),
    ('decoder', POINTER(DecodeImageHandler)),
    ('encoder', POINTER(EncodeImageHandler)),
    ('magick', POINTER(IsImageFormatHandler)),
    ('client_data', c_void_p),
    ('adjoin', MagickBooleanType),
    ('raw', MagickBooleanType),
    ('endian_support', MagickBooleanType),
    ('blob_support', MagickBooleanType),
    ('seekable_stream', MagickBooleanType),
    ('thread_support', MagickStatusType),
    ('stealth', MagickBooleanType),
    ('previous', POINTER(_MagickInfo)),
    ('next', POINTER(_MagickInfo)),
    ('signature', c_ulong),
]
MagickInfo = _MagickInfo

class _MimeInfo(Structure):
    pass
_MimeInfo._fields_ = [
]
MimeInfo = _MimeInfo
##MagickToMime = _lib.MagickToMime
##MagickToMime.restype = STRING
##MagickToMime.argtypes = [STRING]

# values for enumeration 'MagickModuleType'
MagickModuleType = c_int # enum
class _ModuleInfo(Structure):
    pass
__time_t = c_long
time_t = __time_t
_ModuleInfo._fields_ = [
    ('path', STRING),
    ('tag', STRING),
    ('handle', c_void_p),
    ('unregister_module', CFUNCTYPE(None)),
    ('register_module', CFUNCTYPE(c_ulong)),
    ('load_time', time_t),
    ('stealth', MagickBooleanType),
    ('previous', POINTER(_ModuleInfo)),
    ('next', POINTER(_ModuleInfo)),
    ('signature', c_ulong),
]
ModuleInfo = _ModuleInfo
ImageFilterHandler = CFUNCTYPE(c_ulong, POINTER(POINTER(Image)), c_int, POINTER(STRING), POINTER(ExceptionInfo))

# values for enumeration 'MontageMode'
MontageMode = c_int # enum
class _MontageInfo(Structure):
    pass
_MontageInfo._pack_ = 4
_MontageInfo._fields_ = [
    ('geometry', STRING),
    ('tile', STRING),
    ('title', STRING),
    ('frame', STRING),
    ('texture', STRING),
    ('font', STRING),
    ('pointsize', c_double),
    ('border_width', c_ulong),
    ('shadow', MagickBooleanType),
    ('fill', PixelPacket),
    ('stroke', PixelPacket),
    ('background_color', PixelPacket),
    ('border_color', PixelPacket),
    ('matte_color', PixelPacket),
    ('gravity', GravityType),
    ('filename', c_char * 4096),
    ('debug', MagickBooleanType),
    ('signature', c_ulong),
]
MontageInfo = _MontageInfo

# values for enumeration 'MagickOption'
MagickOption = c_int # enum
class _OptionInfo(Structure):
    pass
_OptionInfo._fields_ = [
    ('mnemonic', STRING),
    ('type', c_long),
]
OptionInfo = _OptionInfo

class _LongPixelPacket(Structure):
    pass
_LongPixelPacket._fields_ = [
    ('red', c_ulong),
    ('green', c_ulong),
    ('blue', c_ulong),
    ('opacity', c_ulong),
    ('index', c_ulong),
]
LongPixelPacket = _LongPixelPacket

class _StringInfo(Structure):
    pass
StringInfo = _StringInfo

class _QuantizeInfo(Structure):
    pass
_QuantizeInfo._fields_ = [
    ('number_colors', c_ulong),
    ('tree_depth', c_ulong),
    ('dither', MagickBooleanType),
    ('colorspace', ColorspaceType),
    ('measure_error', MagickBooleanType),
    ('signature', c_ulong),
]
QuantizeInfo = _QuantizeInfo

# values for enumeration 'QuantumFormatType'
QuantumFormatType = c_int # enum
class _QuantumInfo(Structure):
    pass
_QuantumInfo._pack_ = 4
_QuantumInfo._fields_ = [
    ('quantum', c_ulong),
    ('format', QuantumFormatType),
    ('minimum', c_double),
    ('maximum', c_double),
    ('scale', c_double),
    ('pad', size_t),
    ('min_is_white', MagickBooleanType),
    ('pack', MagickBooleanType),
    ('semaphore', POINTER(SemaphoreInfo)),
    ('signature', c_ulong),
]
QuantumInfo = _QuantumInfo

class _ResampleFilter(Structure):
    pass
_ResampleFilter._fields_ = [
]
ResampleFilter = _ResampleFilter

# values for enumeration 'ResourceType'
ResourceType = c_int # enum
SemaphoreInfo._fields_ = [
]

class _SignatureInfo(Structure):
    pass
_SignatureInfo._fields_ = [
]

class _SplayTreeInfo(Structure):
    pass
_SplayTreeInfo._fields_ = [
]
SplayTreeInfo = _SplayTreeInfo

class _ChannelStatistics(Structure):
    pass
_ChannelStatistics._pack_ = 4
_ChannelStatistics._fields_ = [
    ('depth', c_ulong),
    ('minima', c_double),
    ('maxima', c_double),
    ('mean', c_double),
    ('standard_deviation', c_double),
]
ChannelStatistics = _ChannelStatistics

_StringInfo._fields_ = [
    ('path', c_char * 4096),
    ('datum', POINTER(c_ubyte)),
    ('length', size_t),
    ('signature', c_ulong),
]

class _ThresholdMap(Structure):
    pass
_ThresholdMap._fields_ = [
]
ThresholdMap = _ThresholdMap

class _TokenInfo(Structure):
    pass
_TokenInfo._fields_ = [
]
TokenInfo = _TokenInfo

class _TypeInfo(Structure):
    pass
_TypeInfo._fields_ = [
    ('face', c_ulong),
    ('path', STRING),
    ('name', STRING),
    ('description', STRING),
    ('family', STRING),
    ('style', StyleType),
    ('stretch', StretchType),
    ('weight', c_ulong),
    ('encoding', STRING),
    ('foundry', STRING),
    ('format', STRING),
    ('metrics', STRING),
    ('glyphs', STRING),
    ('stealth', MagickBooleanType),
    ('previous', POINTER(_TypeInfo)),
    ('next', POINTER(_TypeInfo)),
    ('signature', c_ulong),
]
TypeInfo = _TypeInfo

# values for enumeration 'PathType'
PathType = c_int # enum
try:
        GetMagickQuantumDepth = _lib.GetMagickQuantumDepth
        GetMagickQuantumDepth.restype = STRING
        GetMagickQuantumDepth.argtypes = [POINTER(c_ulong)]
        GetMagickQuantumRange = _lib.GetMagickQuantumRange
        GetMagickQuantumRange.restype = STRING
        GetMagickQuantumRange.argtypes = [POINTER(c_ulong)]
except: pass

class _XMLTreeInfo(Structure):
    pass
_XMLTreeInfo._fields_ = [
]
XMLTreeInfo = _XMLTreeInfo
class _XImportInfo(Structure):
    pass
_XImportInfo._fields_ = [
    ('frame', MagickBooleanType),
    ('borders', MagickBooleanType),
    ('screen', MagickBooleanType),
    ('descend', MagickBooleanType),
    ('silent', MagickBooleanType),
]
XImportInfo = _XImportInfo

class _MagickWand(Structure):
    pass
_MagickWand._fields_ = [
    ('id', c_ulong),
    ('name', STRING),
    ('exception', POINTER(ExceptionInfo)),
    ('image_info', POINTER(ImageInfo)),
    ('quantize_info', POINTER(QuantizeInfo)),
    ('images', POINTER(Image)),
    ('active', MagickBooleanType),
    ('pend', MagickBooleanType),
    ('debug', MagickBooleanType),
    ('signature', c_ulong),	
]
MagickWand = _MagickWand
MagickGetException = _lib.MagickGetException
MagickGetException.restype = STRING
MagickGetException.argtypes = [POINTER(MagickWand), POINTER(ExceptionType)]
IsMagickWand = _lib.IsMagickWand
IsMagickWand.restype = MagickBooleanType
IsMagickWand.argtypes = [POINTER(MagickWand)]
MagickClearException = _lib.MagickClearException
MagickClearException.restype = MagickBooleanType
MagickClearException.argtypes = [POINTER(MagickWand)]
CloneMagickWand = _lib.CloneMagickWand
CloneMagickWand.restype = POINTER(MagickWand)
CloneMagickWand.argtypes = [POINTER(MagickWand)]
DestroyMagickWand = _lib.DestroyMagickWand
DestroyMagickWand.restype = POINTER(MagickWand)
DestroyMagickWand.argtypes = [POINTER(MagickWand)]
NewMagickWand = _lib.NewMagickWand
NewMagickWand.restype = POINTER(MagickWand)
NewMagickWand.argtypes = []
NewMagickWandFromImage = _lib.NewMagickWandFromImage
NewMagickWandFromImage.restype = POINTER(MagickWand)
NewMagickWandFromImage.argtypes = [POINTER(Image)]
ClearMagickWand = _lib.ClearMagickWand
ClearMagickWand.restype = None
ClearMagickWand.argtypes = [POINTER(MagickWand)]
MagickWandGenesis = _lib.MagickWandGenesis
MagickWandGenesis.restype = None
MagickWandGenesis.argtypes = []
MagickWandTerminus = _lib.MagickWandTerminus
MagickWandTerminus.restype = None
MagickWandTerminus.argtypes = []
MagickRelinquishMemory = _lib.MagickRelinquishMemory
MagickRelinquishMemory.restype = c_void_p
MagickRelinquishMemory.argtypes = [c_void_p]

    
# values for enumeration 'PathMode'
PathMode = c_int # enum
# values for enumeration 'PathOperation'
PathOperation = c_int # enum

class _DrawingWand(Structure):
    pass
_DrawingWand._fields_ = [
    ('id', c_ulong),
    ('name', STRING),
    ('image', POINTER(Image)),
    ('exception', POINTER(ExceptionInfo)),
    ('mvg', STRING),
    ('mvg_alloc', size_t),
    ('mvg_lenght', size_t),
    ('mvg_width', c_ulong),
    ('pattern_id', STRING),
    ('pattern_bounds', RectangleInfo),
    ('pattern_offset', size_t),
    ('index', c_ulong),
    ('graphic_context', POINTER(DrawInfo)),
    ('filter_off', MagickBooleanType),
    ('indent_depth', c_ulong),
    ('path_operation', PathOperation),#############################
    ('path_mode', PathMode),
    ('destroy', MagickBooleanType),
    ('debug', MagickBooleanType),
    ('signature', c_ulong),
]
DrawContext = POINTER(_DrawingWand)
DrawingWand = _DrawingWand

class _PixelIterator(Structure):
    pass
PixelIterator = _PixelIterator

    
class _PixelWand(Structure):
    pass
_PixelWand._fields_ = [
    ('id', c_ulong),
    ('name', STRING),
    ('exception', POINTER(ExceptionInfo)),
    ('pixel', MagickPixelPacket),
    ('count', c_ulong),
    ('debug', MagickBooleanType),
    ('signature', c_ulong),
]
PixelWand = _PixelWand

    
try:
    MagickPaintOpaqueImage = _lib.MagickPaintOpaqueImage
except:
    MagickPaintOpaqueImage = _lib.MagickOpaquePaintImage
MagickPaintOpaqueImage.restype = MagickBooleanType
MagickPaintOpaqueImage.argtypes = [POINTER(MagickWand), POINTER(PixelWand), POINTER(PixelWand), c_double]

    
DestroyDrawingWand = _lib.DestroyDrawingWand
DestroyDrawingWand.restype = POINTER(DrawingWand)
DestroyDrawingWand.argtypes = [POINTER(DrawingWand)]

NewDrawingWand = _lib.NewDrawingWand
NewDrawingWand.restype = POINTER(DrawingWand)
NewDrawingWand.argtypes = []

DrawCircle = _lib.DrawCircle
DrawCircle.restype = None
DrawCircle.argtypes = [POINTER(DrawingWand), c_double, c_double, c_double, c_double]

DrawSetFillColor = _lib.DrawSetFillColor
DrawSetFillColor.restype = None
DrawSetFillColor.argtypes = [POINTER(DrawingWand), POINTER(PixelWand)]


MagickGetImageChannelStatistics = _lib.MagickGetImageChannelStatistics
MagickGetImageChannelStatistics.restype = POINTER(ChannelStatistics)
MagickGetImageChannelStatistics.argtypes = [POINTER(MagickWand)]
MagickGetImageFilename = _lib.MagickGetImageFilename
MagickGetImageFilename.restype = STRING
MagickGetImageFilename.argtypes = [POINTER(MagickWand)]
MagickGetImageFormat = _lib.MagickGetImageFormat
MagickGetImageFormat.restype = STRING
MagickGetImageFormat.argtypes = [POINTER(MagickWand)]
MagickGetImageSignature = _lib.MagickGetImageSignature
MagickGetImageSignature.restype = STRING
MagickGetImageSignature.argtypes = [POINTER(MagickWand)]
MagickIdentifyImage = _lib.MagickIdentifyImage
MagickIdentifyImage.restype = STRING
MagickIdentifyImage.argtypes = [POINTER(MagickWand)]
MagickGetImageCompose = _lib.MagickGetImageCompose
MagickGetImageCompose.restype = CompositeOperator
MagickGetImageCompose.argtypes = [POINTER(MagickWand)]
MagickGetImageColorspace = _lib.MagickGetImageColorspace
MagickGetImageColorspace.restype = ColorspaceType
MagickGetImageColorspace.argtypes = [POINTER(MagickWand)]
MagickGetImageCompression = _lib.MagickGetImageCompression
MagickGetImageCompression.restype = CompressionType
MagickGetImageCompression.argtypes = [POINTER(MagickWand)]
MagickGetImageDispose = _lib.MagickGetImageDispose
MagickGetImageDispose.restype = DisposeType
MagickGetImageDispose.argtypes = [POINTER(MagickWand)]
MagickGetImageGamma = _lib.MagickGetImageGamma
MagickGetImageGamma.restype = c_double
MagickGetImageGamma.argtypes = [POINTER(MagickWand)]
MagickGetImageTotalInkDensity = _lib.MagickGetImageTotalInkDensity
MagickGetImageTotalInkDensity.restype = c_double
MagickGetImageTotalInkDensity.argtypes = [POINTER(MagickWand)]
GetImageFromMagickWand = _lib.GetImageFromMagickWand
GetImageFromMagickWand.restype = POINTER(Image)
GetImageFromMagickWand.argtypes = [POINTER(MagickWand)]
MagickGetImageType = _lib.MagickGetImageType
MagickGetImageType.restype = ImageType
MagickGetImageType.argtypes = [POINTER(MagickWand)]
MagickGetImageInterlaceScheme = _lib.MagickGetImageInterlaceScheme
MagickGetImageInterlaceScheme.restype = InterlaceType
MagickGetImageInterlaceScheme.argtypes = [POINTER(MagickWand)]
MagickAdaptiveThresholdImage = _lib.MagickAdaptiveThresholdImage
MagickAdaptiveThresholdImage.restype = MagickBooleanType
MagickAdaptiveThresholdImage.argtypes = [POINTER(MagickWand), c_ulong, c_ulong, c_long]
MagickAddImage = _lib.MagickAddImage
MagickAddImage.restype = MagickBooleanType
MagickAddImage.argtypes = [POINTER(MagickWand), POINTER(MagickWand)]
MagickAddNoiseImage = _lib.MagickAddNoiseImage
MagickAddNoiseImage.restype = MagickBooleanType
MagickAddNoiseImage.argtypes = [POINTER(MagickWand), NoiseType]
MagickAffineTransformImage = _lib.MagickAffineTransformImage
MagickAffineTransformImage.restype = MagickBooleanType
MagickAffineTransformImage.argtypes = [POINTER(MagickWand), POINTER(DrawingWand)]
MagickAnnotateImage = _lib.MagickAnnotateImage
MagickAnnotateImage.restype = MagickBooleanType
MagickAnnotateImage.argtypes = [POINTER(MagickWand), POINTER(DrawingWand), c_double, c_double, c_double, STRING]
MagickAnimateImages = _lib.MagickAnimateImages
MagickAnimateImages.restype = MagickBooleanType
MagickAnimateImages.argtypes = [POINTER(MagickWand), STRING]
MagickBlackThresholdImage = _lib.MagickBlackThresholdImage
MagickBlackThresholdImage.restype = MagickBooleanType
MagickBlackThresholdImage.argtypes = [POINTER(MagickWand), POINTER(PixelWand)]
MagickBlurImage = _lib.MagickBlurImage
MagickBlurImage.restype = MagickBooleanType
MagickBlurImage.argtypes = [POINTER(MagickWand), c_double, c_double]
MagickAdaptiveBlurImage = _lib.MagickAdaptiveBlurImage
MagickAdaptiveBlurImage.restype = MagickBooleanType
MagickAdaptiveBlurImage.argtypes = [POINTER(MagickWand), c_double, c_double]
MagickBlurImageChannel = _lib.MagickBlurImageChannel
MagickBlurImageChannel.restype = MagickBooleanType
MagickBlurImageChannel.argtypes = [POINTER(MagickWand), ChannelType, c_double, c_double]
MagickBorderImage = _lib.MagickBorderImage
MagickBorderImage.restype = MagickBooleanType
MagickBorderImage.argtypes = [POINTER(MagickWand), POINTER(PixelWand), c_ulong, c_ulong]
MagickCharcoalImage = _lib.MagickCharcoalImage
MagickCharcoalImage.restype = MagickBooleanType
MagickCharcoalImage.argtypes = [POINTER(MagickWand), c_double, c_double]
MagickChopImage = _lib.MagickChopImage
MagickChopImage.restype = MagickBooleanType
MagickChopImage.argtypes = [POINTER(MagickWand), c_ulong, c_ulong, c_long, c_long]
MagickClipImage = _lib.MagickClipImage
MagickClipImage.restype = MagickBooleanType
MagickClipImage.argtypes = [POINTER(MagickWand)]
MagickColorizeImage = _lib.MagickColorizeImage
MagickColorizeImage.restype = MagickBooleanType
MagickColorizeImage.argtypes = [POINTER(MagickWand), POINTER(PixelWand), POINTER(PixelWand)]
MagickCommentImage = _lib.MagickCommentImage
MagickCommentImage.restype = MagickBooleanType
MagickCommentImage.argtypes = [POINTER(MagickWand), STRING]
MagickCompositeImage = _lib.MagickCompositeImage
MagickCompositeImage.restype = MagickBooleanType
MagickCompositeImage.argtypes = [POINTER(MagickWand), POINTER(MagickWand), CompositeOperator, c_long, c_long]
MagickConstituteImage = _lib.MagickConstituteImage
MagickConstituteImage.restype = MagickBooleanType
MagickConstituteImage.argtypes = [POINTER(MagickWand), c_ulong, c_ulong, STRING, StorageType, c_void_p]
MagickContrastImage = _lib.MagickContrastImage
MagickContrastImage.restype = MagickBooleanType
MagickContrastImage.argtypes = [POINTER(MagickWand), MagickBooleanType]
MagickContrastStretchImage = _lib.MagickContrastStretchImage
MagickContrastStretchImage.restype = MagickBooleanType
MagickContrastStretchImage.argtypes = [POINTER(MagickWand), c_double, c_double]
MagickConvolveImage = _lib.MagickConvolveImage
MagickConvolveImage.restype = MagickBooleanType
MagickConvolveImage.argtypes = [POINTER(MagickWand), c_ulong, POINTER(c_double)]
MagickConvolveImageChannel = _lib.MagickConvolveImageChannel
MagickConvolveImageChannel.restype = MagickBooleanType
MagickConvolveImageChannel.argtypes = [POINTER(MagickWand), ChannelType, c_ulong, POINTER(c_double)]
MagickCropImage = _lib.MagickCropImage
MagickCropImage.restype = MagickBooleanType
MagickCropImage.argtypes = [POINTER(MagickWand), c_ulong, c_ulong, c_long, c_long]

MagickExtentImage=_lib.MagickExtentImage
MagickExtentImage.restype = MagickBooleanType
MagickExtentImage.argtypes = [POINTER(MagickWand), c_ulong, c_ulong, c_long, c_long]

MagickCycleColormapImage = _lib.MagickCycleColormapImage
MagickCycleColormapImage.restype = MagickBooleanType
MagickCycleColormapImage.argtypes = [POINTER(MagickWand), c_long]
MagickDespeckleImage = _lib.MagickDespeckleImage
MagickDespeckleImage.restype = MagickBooleanType
MagickDespeckleImage.argtypes = [POINTER(MagickWand)]
MagickDisplayImage = _lib.MagickDisplayImage
MagickDisplayImage.restype = MagickBooleanType
MagickDisplayImage.argtypes = [POINTER(MagickWand), STRING]
MagickDisplayImages = _lib.MagickDisplayImages
MagickDisplayImages.restype = MagickBooleanType
MagickDisplayImages.argtypes = [POINTER(MagickWand), STRING]
MagickDistortImage = _lib.MagickDistortImage
MagickDistortImage.restype = MagickBooleanType
MagickDistortImage.argtypes = [POINTER(MagickWand), DistortImageMethod, c_ulong, POINTER(c_double) , MagickBooleanType]
MagickDrawImage = _lib.MagickDrawImage
MagickDrawImage.restype = MagickBooleanType
MagickDrawImage.argtypes = [POINTER(MagickWand), POINTER(DrawingWand)]
MagickEdgeImage = _lib.MagickEdgeImage
MagickEdgeImage.restype = MagickBooleanType
MagickEdgeImage.argtypes = [POINTER(MagickWand), c_double]
MagickEmbossImage = _lib.MagickEmbossImage
MagickEmbossImage.restype = MagickBooleanType
MagickEmbossImage.argtypes = [POINTER(MagickWand), c_double, c_double]
MagickEnhanceImage = _lib.MagickEnhanceImage
MagickEnhanceImage.restype = MagickBooleanType
MagickEnhanceImage.argtypes = [POINTER(MagickWand)]
MagickEqualizeImage = _lib.MagickEqualizeImage
MagickEqualizeImage.restype = MagickBooleanType
MagickEqualizeImage.argtypes = [POINTER(MagickWand)]
MagickEvaluateImage = _lib.MagickEvaluateImage
MagickEvaluateImage.restype = MagickBooleanType
MagickEvaluateImage.argtypes = [POINTER(MagickWand), MagickEvaluateOperator, c_double]
MagickEvaluateImageChannel = _lib.MagickEvaluateImageChannel
MagickEvaluateImageChannel.restype = MagickBooleanType
MagickEvaluateImageChannel.argtypes = [POINTER(MagickWand), ChannelType, MagickEvaluateOperator, c_double]
MagickFlipImage = _lib.MagickFlipImage
MagickFlipImage.restype = MagickBooleanType
MagickFlipImage.argtypes = [POINTER(MagickWand)]
MagickFlopImage = _lib.MagickFlopImage
MagickFlopImage.restype = MagickBooleanType
MagickFlopImage.argtypes = [POINTER(MagickWand)]
MagickFrameImage = _lib.MagickFrameImage
MagickFrameImage.restype = MagickBooleanType
MagickFrameImage.argtypes = [POINTER(MagickWand), POINTER(PixelWand), c_ulong, c_ulong, c_long, c_long]
MagickFunctionImage = _lib.MagickFunctionImage
MagickFunctionImage.restype = MagickBooleanType
MagickFunctionImage.argtypes = [POINTER(MagickWand), MagickFunction, c_ulong, POINTER(c_double)]
MagickFunctionImageChannel = _lib.MagickFunctionImageChannel
MagickFunctionImageChannel.restype = MagickBooleanType
MagickFunctionImageChannel.argtypes = [POINTER(MagickWand), ChannelType, MagickFunction, c_ulong, POINTER(c_double)]
MagickGammaImage = _lib.MagickGammaImage
MagickGammaImage.restype = MagickBooleanType
MagickGammaImage.argtypes = [POINTER(MagickWand), c_double]
MagickGammaImageChannel = _lib.MagickGammaImageChannel
MagickGammaImageChannel.restype = MagickBooleanType
MagickGammaImageChannel.argtypes = [POINTER(MagickWand), ChannelType, c_double]
MagickGaussianBlurImage = _lib.MagickGaussianBlurImage
MagickGaussianBlurImage.restype = MagickBooleanType
MagickGaussianBlurImage.argtypes = [POINTER(MagickWand), c_double, c_double]
MagickGaussianBlurImageChannel = _lib.MagickGaussianBlurImageChannel
MagickGaussianBlurImageChannel.restype = MagickBooleanType
MagickGaussianBlurImageChannel.argtypes = [POINTER(MagickWand), ChannelType, c_double, c_double]
MagickGetImageAlphaChannel = _lib.MagickGetImageAlphaChannel
MagickGetImageAlphaChannel.restype = MagickBooleanType
MagickGetImageAlphaChannel.argtypes = [POINTER(MagickWand)]
MagickGetImageBackgroundColor = _lib.MagickGetImageBackgroundColor
MagickGetImageBackgroundColor.restype = MagickBooleanType
MagickGetImageBackgroundColor.argtypes = [POINTER(MagickWand), POINTER(PixelWand)]
MagickGetImageBluePrimary = _lib.MagickGetImageBluePrimary
MagickGetImageBluePrimary.restype = MagickBooleanType
MagickGetImageBluePrimary.argtypes = [POINTER(MagickWand), POINTER(c_double), POINTER(c_double)]
MagickGetImageBorderColor = _lib.MagickGetImageBorderColor
MagickGetImageBorderColor.restype = MagickBooleanType
MagickGetImageBorderColor.argtypes = [POINTER(MagickWand), POINTER(PixelWand)]
MagickGetImageChannelDistortion = _lib.MagickGetImageChannelDistortion
MagickGetImageChannelDistortion.restype = MagickBooleanType
MagickGetImageChannelDistortion.argtypes = [POINTER(MagickWand), POINTER(MagickWand), ChannelType, MetricType, POINTER(c_double)]
MagickGetImageDistortion = _lib.MagickGetImageDistortion
MagickGetImageDistortion.restype = MagickBooleanType
MagickGetImageDistortion.argtypes = [POINTER(MagickWand), POINTER(MagickWand), MetricType, POINTER(c_double)]
MagickGetImageChannelMean = _lib.MagickGetImageChannelMean
MagickGetImageChannelMean.restype = MagickBooleanType
MagickGetImageChannelMean.argtypes = [POINTER(MagickWand), ChannelType, POINTER(c_double), POINTER(c_double)]
MagickGetImageColormapColor = _lib.MagickGetImageColormapColor
MagickGetImageColormapColor.restype = MagickBooleanType
MagickGetImageColormapColor.argtypes = [POINTER(MagickWand), c_ulong, POINTER(PixelWand)]
MagickGetImageGreenPrimary = _lib.MagickGetImageGreenPrimary
MagickGetImageGreenPrimary.restype = MagickBooleanType
MagickGetImageGreenPrimary.argtypes = [POINTER(MagickWand), POINTER(c_double), POINTER(c_double)]
MagickGetImageMatteColor = _lib.MagickGetImageMatteColor
MagickGetImageMatteColor.restype = MagickBooleanType
MagickGetImageMatteColor.argtypes = [POINTER(MagickWand), POINTER(PixelWand)]
MagickGetImagePage = _lib.MagickGetImagePage
MagickGetImagePage.restype = MagickBooleanType
MagickGetImagePage.argtypes = [POINTER(MagickWand), POINTER(c_ulong), POINTER(c_ulong), POINTER(c_long), POINTER(c_long)]
MagickGetImagePixelColor = _lib.MagickGetImagePixelColor
MagickGetImagePixelColor.restype = MagickBooleanType
MagickGetImagePixelColor.argtypes = [POINTER(MagickWand), c_long, c_long, POINTER(PixelWand)]
try:
	MagickGetImagePixels = _lib.MagickGetImagePixels
except AttributeError:	
	try:
		MagickGetImagePixels = _lib.MagickExportImagePixels
	except AttributeError:	
		MagickGetImagePixels = _lib.MagickGetAuthenticPixels
except:
	traceback.print_exc()
MagickGetImagePixels.restype = MagickBooleanType
MagickGetImagePixels.argtypes = [POINTER(MagickWand), c_long, c_long, c_ulong, c_ulong, STRING, StorageType, c_void_p]
MagickGetImageRedPrimary = _lib.MagickGetImageRedPrimary
MagickGetImageRedPrimary.restype = MagickBooleanType
MagickGetImageRedPrimary.argtypes = [POINTER(MagickWand), POINTER(c_double), POINTER(c_double)]
MagickGetImageResolution = _lib.MagickGetImageResolution
MagickGetImageResolution.restype = MagickBooleanType
MagickGetImageResolution.argtypes = [POINTER(MagickWand), POINTER(c_double), POINTER(c_double)]
MagickGetImageWhitePoint = _lib.MagickGetImageWhitePoint
MagickGetImageWhitePoint.restype = MagickBooleanType
MagickGetImageWhitePoint.argtypes = [POINTER(MagickWand), POINTER(c_double), POINTER(c_double)]
MagickHasNextImage = _lib.MagickHasNextImage
MagickHasNextImage.restype = MagickBooleanType
MagickHasNextImage.argtypes = [POINTER(MagickWand)]
MagickHasPreviousImage = _lib.MagickHasPreviousImage
MagickHasPreviousImage.restype = MagickBooleanType
MagickHasPreviousImage.argtypes = [POINTER(MagickWand)]
MagickImplodeImage = _lib.MagickImplodeImage
MagickImplodeImage.restype = MagickBooleanType
MagickImplodeImage.argtypes = [POINTER(MagickWand), c_double]
MagickLabelImage = _lib.MagickLabelImage
MagickLabelImage.restype = MagickBooleanType
MagickLabelImage.argtypes = [POINTER(MagickWand), STRING]
MagickLevelImage = _lib.MagickLevelImage
MagickLevelImage.restype = MagickBooleanType
MagickLevelImage.argtypes = [POINTER(MagickWand), c_double, c_double, c_double]
MagickLevelImageChannel = _lib.MagickLevelImageChannel
MagickLevelImageChannel.restype = MagickBooleanType
MagickLevelImageChannel.argtypes = [POINTER(MagickWand), ChannelType, c_double, c_double, c_double]
MagickMagnifyImage = _lib.MagickMagnifyImage
MagickMagnifyImage.restype = MagickBooleanType
MagickMagnifyImage.argtypes = [POINTER(MagickWand)]
MagickMedianFilterImage = _lib.MagickMedianFilterImage
MagickMedianFilterImage.restype = MagickBooleanType
MagickMedianFilterImage.argtypes = [POINTER(MagickWand), c_double]
MagickMergeImageLayers = _lib.MagickMergeImageLayers
MagickMergeImageLayers.restype = POINTER(MagickWand)
MagickMergeImageLayers.argtypes = [POINTER(MagickWand), ImageLayerMethod]
MagickMinifyImage = _lib.MagickMinifyImage
MagickMinifyImage.restype = MagickBooleanType
MagickMinifyImage.argtypes = [POINTER(MagickWand)]
MagickModulateImage = _lib.MagickModulateImage
MagickModulateImage.restype = MagickBooleanType
MagickModulateImage.argtypes = [POINTER(MagickWand), c_double, c_double, c_double]
MagickMotionBlurImage = _lib.MagickMotionBlurImage
MagickMotionBlurImage.restype = MagickBooleanType
MagickMotionBlurImage.argtypes = [POINTER(MagickWand), c_double, c_double, c_double]
MagickNegateImage = _lib.MagickNegateImage
MagickNegateImage.restype = MagickBooleanType
MagickNegateImage.argtypes = [POINTER(MagickWand), MagickBooleanType]
MagickNegateImageChannel = _lib.MagickNegateImageChannel
MagickNegateImageChannel.restype = MagickBooleanType
MagickNegateImageChannel.argtypes = [POINTER(MagickWand), ChannelType, MagickBooleanType]
MagickNewImage = _lib.MagickNewImage
MagickNewImage.restype = MagickBooleanType
MagickNewImage.argtypes = [POINTER(MagickWand), c_ulong, c_ulong, POINTER(PixelWand)]
MagickNextImage = _lib.MagickNextImage
MagickNextImage.restype = MagickBooleanType
MagickNextImage.argtypes = [POINTER(MagickWand)]
MagickNormalizeImage = _lib.MagickNormalizeImage
MagickNormalizeImage.restype = MagickBooleanType
MagickNormalizeImage.argtypes = [POINTER(MagickWand)]
MagickOilPaintImage = _lib.MagickOilPaintImage
MagickOilPaintImage.restype = MagickBooleanType
MagickOilPaintImage.argtypes = [POINTER(MagickWand), c_double]
MagickPingImage = _lib.MagickPingImage
MagickPingImage.restype = MagickBooleanType
MagickPingImage.argtypes = [POINTER(MagickWand), STRING]
MagickPosterizeImage = _lib.MagickPosterizeImage
MagickPosterizeImage.restype = MagickBooleanType
MagickPosterizeImage.argtypes = [POINTER(MagickWand), c_ulong, MagickBooleanType]
MagickPreviousImage = _lib.MagickPreviousImage
MagickPreviousImage.restype = MagickBooleanType
MagickPreviousImage.argtypes = [POINTER(MagickWand)]
MagickQuantizeImage = _lib.MagickQuantizeImage
MagickQuantizeImage.restype = MagickBooleanType
MagickQuantizeImage.argtypes = [POINTER(MagickWand), c_ulong, ColorspaceType, c_ulong, MagickBooleanType, MagickBooleanType]
MagickQuantizeImages = _lib.MagickQuantizeImages
MagickQuantizeImages.restype = MagickBooleanType
MagickQuantizeImages.argtypes = [POINTER(MagickWand), c_ulong, ColorspaceType, c_ulong, MagickBooleanType, MagickBooleanType]
MagickRadialBlurImage = _lib.MagickRadialBlurImage
MagickRadialBlurImage.restype = MagickBooleanType
MagickRadialBlurImage.argtypes = [POINTER(MagickWand), c_double]
MagickRadialBlurImageChannel = _lib.MagickRadialBlurImageChannel
MagickRadialBlurImageChannel.restype = MagickBooleanType
MagickRadialBlurImageChannel.argtypes = [POINTER(MagickWand), ChannelType, c_double]
MagickRaiseImage = _lib.MagickRaiseImage
MagickRaiseImage.restype = MagickBooleanType
MagickRaiseImage.argtypes = [POINTER(MagickWand), c_ulong, c_ulong, c_long, c_long, MagickBooleanType]
MagickReadImage = _lib.MagickReadImage
MagickReadImage.restype = MagickBooleanType
MagickReadImage.argtypes = [POINTER(MagickWand), STRING]
MagickReadImageBlob = _lib.MagickReadImageBlob
MagickReadImageBlob.restype = MagickBooleanType
MagickReadImageBlob.argtypes = [POINTER(MagickWand), c_void_p, size_t]
MagickReadImageFile = _lib.MagickReadImageFile
MagickReadImageFile.restype = MagickBooleanType
MagickReadImageFile.argtypes = [POINTER(MagickWand), POINTER(FILE)]
MagickRecolorImage=_lib.MagickRecolorImage
MagickRecolorImage.restype= MagickBooleanType
MagickRecolorImage.argtypes= [POINTER(MagickWand), c_ulong, POINTER(c_double)]
MagickReduceNoiseImage = _lib.MagickReduceNoiseImage
MagickReduceNoiseImage.restype = MagickBooleanType
MagickReduceNoiseImage.argtypes = [POINTER(MagickWand), c_double]
MagickRemoveImage = _lib.MagickRemoveImage
MagickRemoveImage.restype = MagickBooleanType
MagickRemoveImage.argtypes = [POINTER(MagickWand)]
MagickResampleImage = _lib.MagickResampleImage
MagickResampleImage.restype = MagickBooleanType
MagickResampleImage.argtypes = [POINTER(MagickWand), c_double, c_double, FilterTypes, c_double]
MagickResizeImage = _lib.MagickResizeImage
MagickResizeImage.restype = MagickBooleanType
MagickResizeImage.argtypes = [POINTER(MagickWand), c_ulong, c_ulong, FilterTypes, c_double]
MagickRollImage = _lib.MagickRollImage
MagickRollImage.restype = MagickBooleanType
MagickRollImage.argtypes = [POINTER(MagickWand), c_long, c_long]
MagickRotateImage = _lib.MagickRotateImage
MagickRotateImage.restype = MagickBooleanType
MagickRotateImage.argtypes = [POINTER(MagickWand), POINTER(PixelWand), c_double]
MagickSampleImage = _lib.MagickSampleImage
MagickSampleImage.restype = MagickBooleanType
MagickSampleImage.argtypes = [POINTER(MagickWand), c_ulong, c_ulong]
MagickScaleImage = _lib.MagickScaleImage
MagickScaleImage.restype = MagickBooleanType
MagickScaleImage.argtypes = [POINTER(MagickWand), c_ulong, c_ulong]
MagickSeparateImageChannel = _lib.MagickSeparateImageChannel
MagickSeparateImageChannel.restype = MagickBooleanType
MagickSeparateImageChannel.argtypes = [POINTER(MagickWand), ChannelType]
MagickSepiaToneImage = _lib.MagickSepiaToneImage
MagickSepiaToneImage.restype = MagickBooleanType
MagickSepiaToneImage.argtypes = [POINTER(MagickWand), c_double]
MagickSetImage = _lib.MagickSetImage
MagickSetImage.restype = MagickBooleanType
MagickSetImage.argtypes = [POINTER(MagickWand), POINTER(MagickWand)]
MagickSetImageAlphaChannel = _lib.MagickSetImageAlphaChannel
MagickSetImageAlphaChannel.restype = MagickBooleanType
MagickSetImageAlphaChannel.argtypes = [POINTER(MagickWand), AlphaChannelType]
MagickSetImageBackgroundColor = _lib.MagickSetImageBackgroundColor
MagickSetImageBackgroundColor.restype = MagickBooleanType
MagickSetImageBackgroundColor.argtypes = [POINTER(MagickWand), POINTER(PixelWand)]
MagickSetImageBias = _lib.MagickSetImageBias
MagickSetImageBias.restype = MagickBooleanType
MagickSetImageBias.argtypes = [POINTER(MagickWand), c_double]
MagickSetImageBluePrimary = _lib.MagickSetImageBluePrimary
MagickSetImageBluePrimary.restype = MagickBooleanType
MagickSetImageBluePrimary.argtypes = [POINTER(MagickWand), c_double, c_double]
MagickSetImageBorderColor = _lib.MagickSetImageBorderColor
MagickSetImageBorderColor.restype = MagickBooleanType
MagickSetImageBorderColor.argtypes = [POINTER(MagickWand), POINTER(PixelWand)]
MagickSetImageChannelDepth = _lib.MagickSetImageChannelDepth
MagickSetImageChannelDepth.restype = MagickBooleanType
MagickSetImageChannelDepth.argtypes = [POINTER(MagickWand), ChannelType, c_ulong]
MagickSetImageClipMask = _lib.MagickSetImageClipMask
MagickSetImageClipMask.restype = MagickBooleanType
MagickSetImageClipMask.argtypes = [POINTER(MagickWand), POINTER(MagickWand)]
MagickGetImageClipMask = _lib.MagickGetImageClipMask
MagickGetImageClipMask.restype = POINTER(MagickWand)
MagickGetImageClipMask.argtypes = [POINTER(MagickWand)]
MagickSetImageColormapColor = _lib.MagickSetImageColormapColor
MagickSetImageColormapColor.restype = MagickBooleanType
MagickSetImageColormapColor.argtypes = [POINTER(MagickWand), c_ulong, POINTER(PixelWand)]
MagickSetImageCompose = _lib.MagickSetImageCompose
MagickSetImageCompose.restype = MagickBooleanType
MagickSetImageCompose.argtypes = [POINTER(MagickWand), CompositeOperator]
MagickSetImageCompression = _lib.MagickSetImageCompression
MagickSetImageCompression.restype = MagickBooleanType
MagickSetImageCompression.argtypes = [POINTER(MagickWand), CompressionType]
MagickSetImageDelay = _lib.MagickSetImageDelay
MagickSetImageDelay.restype = MagickBooleanType
MagickSetImageDelay.argtypes = [POINTER(MagickWand), c_ulong]
MagickSetImageDepth = _lib.MagickSetImageDepth
MagickSetImageDepth.restype = MagickBooleanType
MagickSetImageDepth.argtypes = [POINTER(MagickWand), c_ulong]
MagickSetImageDispose = _lib.MagickSetImageDispose
MagickSetImageDispose.restype = MagickBooleanType
MagickSetImageDispose.argtypes = [POINTER(MagickWand), DisposeType]
try:
	MagickSetImageColorspace = _lib.MagickTransformImageColorspace
except AttributeError:
	MagickSetImageColorspace = _lib.MagickSetImageColorspace
MagickSetImageColorspace.restype = MagickBooleanType
MagickSetImageColorspace.argtypes = [POINTER(MagickWand), ColorspaceType]
MagickSetImageCompressionQuality = _lib.MagickSetImageCompressionQuality
MagickSetImageCompressionQuality.restype = MagickBooleanType
MagickSetImageCompressionQuality.argtypes = [POINTER(MagickWand), c_ulong]
MagickSetImageGreenPrimary = _lib.MagickSetImageGreenPrimary
MagickSetImageGreenPrimary.restype = MagickBooleanType
MagickSetImageGreenPrimary.argtypes = [POINTER(MagickWand), c_double, c_double]
MagickSetImageGamma = _lib.MagickSetImageGamma
MagickSetImageGamma.restype = MagickBooleanType
MagickSetImageGamma.argtypes = [POINTER(MagickWand), c_double]
MagickSetImageExtent = _lib.MagickSetImageExtent
MagickSetImageExtent.restype = MagickBooleanType
MagickSetImageExtent.argtypes = [POINTER(MagickWand), c_ulong, c_ulong]
MagickSetImageFilename = _lib.MagickSetImageFilename
MagickSetImageFilename.restype = MagickBooleanType
MagickSetImageFilename.argtypes = [POINTER(MagickWand), STRING]
MagickSetImageFormat = _lib.MagickSetImageFormat
MagickSetImageFormat.restype = MagickBooleanType
MagickSetImageFormat.argtypes = [POINTER(MagickWand), STRING]
MagickSetImageInterlaceScheme = _lib.MagickSetImageInterlaceScheme
MagickSetImageInterlaceScheme.restype = MagickBooleanType
MagickSetImageInterlaceScheme.argtypes = [POINTER(MagickWand), InterlaceType]
MagickSetImageIterations = _lib.MagickSetImageIterations
MagickSetImageIterations.restype = MagickBooleanType
MagickSetImageIterations.argtypes = [POINTER(MagickWand), c_ulong]
MagickSetImageMatteColor = _lib.MagickSetImageMatteColor
MagickSetImageMatteColor.restype = MagickBooleanType
MagickSetImageMatteColor.argtypes = [POINTER(MagickWand), POINTER(PixelWand)]
MagickSetImageMatte = _lib.MagickSetImageMatte
MagickSetImageMatte.restype = MagickBooleanType
MagickSetImageMatte.argtypes = [POINTER(MagickWand), MagickBooleanType]
MagickSetImagePage = _lib.MagickSetImagePage
MagickSetImagePage.restype = MagickBooleanType
MagickSetImagePage.argtypes = [POINTER(MagickWand), c_ulong, c_ulong, c_long, c_long]
try:
	MagickSetImagePixels = _lib.MagickSetImagePixels
except AttributeError:
	try:
		MagickSetImagePixels = _lib.MagickImportImagePixels
	except AttributeError:
		MagickSetImagePixels = _lib.MagickQueueAuthenticPixels
except:
	traceback.print_exc()
MagickSetImagePixels.restype = MagickBooleanType
MagickSetImagePixels.argtypes = [POINTER(MagickWand), c_long, c_long, c_ulong, c_ulong, STRING, StorageType, c_void_p]
MagickSetImageRedPrimary = _lib.MagickSetImageRedPrimary
MagickSetImageRedPrimary.restype = MagickBooleanType
MagickSetImageRedPrimary.argtypes = [POINTER(MagickWand), c_double, c_double]
MagickSetImageRenderingIntent = _lib.MagickSetImageRenderingIntent
MagickSetImageRenderingIntent.restype = MagickBooleanType
MagickSetImageRenderingIntent.argtypes = [POINTER(MagickWand), RenderingIntent]
MagickSetImageResolution = _lib.MagickSetImageResolution
MagickSetImageResolution.restype = MagickBooleanType
MagickSetImageResolution.argtypes = [POINTER(MagickWand), c_double, c_double]
MagickSetImageScene = _lib.MagickSetImageScene
MagickSetImageScene.restype = MagickBooleanType
MagickSetImageScene.argtypes = [POINTER(MagickWand), c_ulong]
MagickSetImageTicksPerSecond = _lib.MagickSetImageTicksPerSecond
MagickSetImageTicksPerSecond.restype = MagickBooleanType
MagickSetImageTicksPerSecond.argtypes = [POINTER(MagickWand), c_long]
MagickSetImageType = _lib.MagickSetImageType
MagickSetImageType.restype = MagickBooleanType
MagickSetImageType.argtypes = [POINTER(MagickWand), ImageType]
MagickSetImageUnits = _lib.MagickSetImageUnits
MagickSetImageUnits.restype = MagickBooleanType
MagickSetImageUnits.argtypes = [POINTER(MagickWand), ResolutionType]
MagickSetImageWhitePoint = _lib.MagickSetImageWhitePoint
MagickSetImageWhitePoint.restype = MagickBooleanType
MagickSetImageWhitePoint.argtypes = [POINTER(MagickWand), c_double, c_double]
MagickShadowImage = _lib.MagickShadowImage
MagickShadowImage.restype = MagickBooleanType
MagickShadowImage.argtypes = [POINTER(MagickWand), c_double, c_double, c_long, c_long]
MagickSharpenImage = _lib.MagickSharpenImage
MagickSharpenImage.restype = MagickBooleanType
MagickSharpenImage.argtypes = [POINTER(MagickWand), c_double, c_double]
MagickSharpenImageChannel = _lib.MagickSharpenImageChannel
MagickSharpenImageChannel.restype = MagickBooleanType
MagickSharpenImageChannel.argtypes = [POINTER(MagickWand), ChannelType, c_double, c_double]
MagickAdaptiveSharpenImage = _lib.MagickAdaptiveSharpenImage
MagickAdaptiveSharpenImage.restype = MagickBooleanType
MagickAdaptiveSharpenImage.argtypes = [POINTER(MagickWand), c_double, c_double]
MagickAdaptiveSharpenImageChannel = _lib.MagickSharpenImageChannel
MagickAdaptiveSharpenImageChannel.restype = MagickBooleanType
MagickAdaptiveSharpenImageChannel.argtypes = [POINTER(MagickWand), ChannelType, c_double, c_double]
MagickShaveImage = _lib.MagickShaveImage
MagickShaveImage.restype = MagickBooleanType
MagickShaveImage.argtypes = [POINTER(MagickWand), c_ulong, c_ulong]
MagickShearImage = _lib.MagickShearImage
MagickShearImage.restype = MagickBooleanType
MagickShearImage.argtypes = [POINTER(MagickWand), POINTER(PixelWand), c_double, c_double]
MagickSigmoidalContrastImage = _lib.MagickSigmoidalContrastImage
MagickSigmoidalContrastImage.restype = MagickBooleanType
MagickSigmoidalContrastImage.argtypes = [POINTER(MagickWand), MagickBooleanType, c_double, c_double]
MagickSigmoidalContrastImageChannel = _lib.MagickSigmoidalContrastImageChannel
MagickSigmoidalContrastImageChannel.restype = MagickBooleanType
MagickSigmoidalContrastImageChannel.argtypes = [POINTER(MagickWand), ChannelType, MagickBooleanType, c_double, c_double]
MagickSketchImage = _lib.MagickSketchImage
MagickSketchImage.restype = MagickBooleanType
MagickSketchImage.argtypes = [POINTER(MagickWand), c_double, c_double, c_double]
MagickSolarizeImage = _lib.MagickSolarizeImage
MagickSolarizeImage.restype = MagickBooleanType
MagickSolarizeImage.argtypes = [POINTER(MagickWand), c_double]
MagickSpliceImage = _lib.MagickSpliceImage
MagickSpliceImage.restype = MagickBooleanType
MagickSpliceImage.argtypes = [POINTER(MagickWand), c_ulong, c_ulong, c_long, c_long]
MagickSpreadImage = _lib.MagickSpreadImage
MagickSpreadImage.restype = MagickBooleanType
MagickSpreadImage.argtypes = [POINTER(MagickWand), c_double]
MagickStripImage = _lib.MagickStripImage
MagickStripImage.restype = MagickBooleanType
MagickStripImage.argtypes = [POINTER(MagickWand)]
MagickSwirlImage = _lib.MagickSwirlImage
MagickSwirlImage.restype = MagickBooleanType
MagickSwirlImage.argtypes = [POINTER(MagickWand), c_double]
MagickTintImage = _lib.MagickTintImage
MagickTintImage.restype = MagickBooleanType
MagickTintImage.argtypes = [POINTER(MagickWand), POINTER(PixelWand), POINTER(PixelWand)]
MagickThresholdImage = _lib.MagickThresholdImage
MagickThresholdImage.restype = MagickBooleanType
MagickThresholdImage.argtypes = [POINTER(MagickWand), c_double]
MagickThresholdImageChannel = _lib.MagickThresholdImageChannel
MagickThresholdImageChannel.restype = MagickBooleanType
MagickThresholdImageChannel.argtypes = [POINTER(MagickWand), ChannelType, c_double]
MagickThumbnailImage = _lib.MagickThumbnailImage
MagickThumbnailImage.restype = MagickBooleanType
MagickThumbnailImage.argtypes = [POINTER(MagickWand), c_ulong, c_ulong]
MagickTrimImage = _lib.MagickTrimImage
MagickTrimImage.restype = MagickBooleanType
MagickTrimImage.argtypes = [POINTER(MagickWand), c_double]
MagickUnsharpMaskImage = _lib.MagickUnsharpMaskImage
MagickUnsharpMaskImage.restype = MagickBooleanType
MagickUnsharpMaskImage.argtypes = [POINTER(MagickWand), c_double, c_double, c_double, c_double]
MagickUnsharpMaskImageChannel = _lib.MagickUnsharpMaskImageChannel
MagickUnsharpMaskImageChannel.restype = MagickBooleanType
MagickUnsharpMaskImageChannel.argtypes = [POINTER(MagickWand), ChannelType, c_double, c_double, c_double, c_double]
MagickWaveImage = _lib.MagickWaveImage
MagickWaveImage.restype = MagickBooleanType
MagickWaveImage.argtypes = [POINTER(MagickWand), c_double, c_double]
MagickWhiteThresholdImage = _lib.MagickWhiteThresholdImage
MagickWhiteThresholdImage.restype = MagickBooleanType
MagickWhiteThresholdImage.argtypes = [POINTER(MagickWand), POINTER(PixelWand)]
MagickWriteImage = _lib.MagickWriteImage
MagickWriteImage.restype = MagickBooleanType
MagickWriteImage.argtypes = [POINTER(MagickWand), STRING]
MagickWriteImageFile = _lib.MagickWriteImageFile
MagickWriteImageFile.restype = MagickBooleanType
MagickWriteImageFile.argtypes = [POINTER(MagickWand), POINTER(FILE)]
MagickWriteImages = _lib.MagickWriteImages
MagickWriteImages.restype = MagickBooleanType
MagickWriteImages.argtypes = [POINTER(MagickWand), STRING, MagickBooleanType]
MagickWriteImagesFile = _lib.MagickWriteImagesFile
MagickWriteImagesFile.restype = MagickBooleanType
MagickWriteImagesFile.argtypes = [POINTER(MagickWand), POINTER(FILE)]
MagickSetImageProgressMonitor = _lib.MagickSetImageProgressMonitor
MagickSetImageProgressMonitor.restype = MagickProgressMonitor
MagickSetImageProgressMonitor.argtypes = [POINTER(MagickWand), MagickProgressMonitor, c_void_p]
MagickAppendImages = _lib.MagickAppendImages
MagickAppendImages.restype = POINTER(MagickWand)
MagickAppendImages.argtypes = [POINTER(MagickWand), MagickBooleanType]
MagickAverageImages = _lib.MagickAverageImages
MagickAverageImages.restype = POINTER(MagickWand)
MagickAverageImages.argtypes = [POINTER(MagickWand)]
MagickCoalesceImages = _lib.MagickCoalesceImages
MagickCoalesceImages.restype = POINTER(MagickWand)
MagickCoalesceImages.argtypes = [POINTER(MagickWand)]
MagickCombineImages = _lib.MagickCombineImages
MagickCombineImages.restype = POINTER(MagickWand)
MagickCombineImages.argtypes = [POINTER(MagickWand), ChannelType]
MagickCompareImageChannels = _lib.MagickCompareImageChannels
MagickCompareImageChannels.restype = POINTER(MagickWand)
MagickCompareImageChannels.argtypes = [POINTER(MagickWand), POINTER(MagickWand), ChannelType, MetricType, POINTER(c_double)]
MagickCompareImages = _lib.MagickCompareImages
MagickCompareImages.restype = POINTER(MagickWand)
MagickCompareImages.argtypes = [POINTER(MagickWand), POINTER(MagickWand), MetricType, POINTER(c_double)]
MagickDeconstructImages = _lib.MagickDeconstructImages
MagickDeconstructImages.restype = POINTER(MagickWand)
MagickDeconstructImages.argtypes = [POINTER(MagickWand)]
MagickFxImage = _lib.MagickFxImage
MagickFxImage.restype = POINTER(MagickWand)
MagickFxImage.argtypes = [POINTER(MagickWand), STRING]
MagickFxImageChannel = _lib.MagickFxImageChannel
MagickFxImageChannel.restype = POINTER(MagickWand)
MagickFxImageChannel.argtypes = [POINTER(MagickWand), ChannelType, STRING]
MagickGetImage = _lib.MagickGetImage
MagickGetImage.restype = POINTER(MagickWand)
MagickGetImage.argtypes = [POINTER(MagickWand)]
MagickGetImageRegion = _lib.MagickGetImageRegion
MagickGetImageRegion.restype = POINTER(MagickWand)
MagickGetImageRegion.argtypes = [POINTER(MagickWand), c_ulong, c_ulong, c_long, c_long]
MagickMorphImages = _lib.MagickMorphImages
MagickMorphImages.restype = POINTER(MagickWand)
MagickMorphImages.argtypes = [POINTER(MagickWand), c_ulong]
MagickMontageImage = _lib.MagickMontageImage
MagickMontageImage.restype = POINTER(MagickWand)
MagickMontageImage.argtypes = [POINTER(MagickWand), POINTER(DrawingWand), STRING, STRING, MontageMode, STRING]
MagickPreviewImages = _lib.MagickPreviewImages
MagickPreviewImages.restype = POINTER(MagickWand)
MagickPreviewImages.argtypes = [POINTER(MagickWand), PreviewType]
MagickSteganoImage = _lib.MagickSteganoImage
MagickSteganoImage.restype = POINTER(MagickWand)
MagickSteganoImage.argtypes = [POINTER(MagickWand), POINTER(MagickWand), c_long]
MagickStereoImage = _lib.MagickStereoImage
MagickStereoImage.restype = POINTER(MagickWand)
MagickStereoImage.argtypes = [POINTER(MagickWand), POINTER(MagickWand)]
MagickTextureImage = _lib.MagickTextureImage
MagickTextureImage.restype = POINTER(MagickWand)
MagickTextureImage.argtypes = [POINTER(MagickWand), POINTER(MagickWand)]
MagickTransformImage = _lib.MagickTransformImage
MagickTransformImage.restype = POINTER(MagickWand)
MagickTransformImage.argtypes = [POINTER(MagickWand), STRING, STRING]
MagickGetImageHistogram = _lib.MagickGetImageHistogram
MagickGetImageHistogram.restype = POINTER(POINTER(PixelWand))
MagickGetImageHistogram.argtypes = [POINTER(MagickWand), POINTER(c_ulong)]
MagickGetImageRenderingIntent = _lib.MagickGetImageRenderingIntent
MagickGetImageRenderingIntent.restype = RenderingIntent
MagickGetImageRenderingIntent.argtypes = [POINTER(MagickWand)]
MagickGetImageUnits = _lib.MagickGetImageUnits
MagickGetImageUnits.restype = ResolutionType
MagickGetImageUnits.argtypes = [POINTER(MagickWand)]
MagickGetImageBlob = _lib.MagickGetImageBlob
MagickGetImageBlob.restype = POINTER(c_ubyte)
MagickGetImageBlob.argtypes = [POINTER(MagickWand), POINTER(size_t)]
MagickGetImagesBlob = _lib.MagickGetImagesBlob
MagickGetImagesBlob.restype = POINTER(c_ubyte)
MagickGetImagesBlob.argtypes = [POINTER(MagickWand), POINTER(size_t)]
MagickGetImageColors = _lib.MagickGetImageColors
MagickGetImageColors.restype = c_ulong
MagickGetImageColors.argtypes = [POINTER(MagickWand)]
MagickGetImageCompressionQuality = _lib.MagickGetImageCompressionQuality
MagickGetImageCompressionQuality.restype = c_ulong
MagickGetImageCompressionQuality.argtypes = [POINTER(MagickWand)]
MagickGetImageDelay = _lib.MagickGetImageDelay
MagickGetImageDelay.restype = c_ulong
MagickGetImageDelay.argtypes = [POINTER(MagickWand)]
MagickGetImageChannelDepth = _lib.MagickGetImageChannelDepth
MagickGetImageChannelDepth.restype = c_ulong
MagickGetImageChannelDepth.argtypes = [POINTER(MagickWand), ChannelType]
MagickGetImageDepth = _lib.MagickGetImageDepth
MagickGetImageDepth.restype = c_ulong
MagickGetImageDepth.argtypes = [POINTER(MagickWand)]
MagickGetImageHeight = _lib.MagickGetImageHeight
MagickGetImageHeight.restype = c_ulong
MagickGetImageHeight.argtypes = [POINTER(MagickWand)]
MagickGetImageIterations = _lib.MagickGetImageIterations
MagickGetImageIterations.restype = c_ulong
MagickGetImageIterations.argtypes = [POINTER(MagickWand)]
MagickGetImageOrientation = _lib.MagickGetImageOrientation
MagickGetImageOrientation.restype = OrientationType
MagickGetImageOrientation.argtypes = [POINTER(MagickWand)]
MagickGetImageScene = _lib.MagickGetImageScene
MagickGetImageScene.restype = c_ulong
MagickGetImageScene.argtypes = [POINTER(MagickWand)]
MagickGetImageTicksPerSecond = _lib.MagickGetImageTicksPerSecond
MagickGetImageTicksPerSecond.restype = c_ulong
MagickGetImageTicksPerSecond.argtypes = [POINTER(MagickWand)]
MagickGetImageWidth = _lib.MagickGetImageWidth
MagickGetImageWidth.restype = c_ulong
MagickGetImageWidth.argtypes = [POINTER(MagickWand)]
MagickGetNumberImages = _lib.MagickGetNumberImages
MagickGetNumberImages.restype = c_ulong
MagickGetNumberImages.argtypes = [POINTER(MagickWand)]
MagickGetImageVirtualPixelMethod = _lib.MagickGetImageVirtualPixelMethod
MagickGetImageVirtualPixelMethod.restype = VirtualPixelMethod
MagickGetImageVirtualPixelMethod.argtypes = [POINTER(MagickWand)]
MagickGetFilename = _lib.MagickGetFilename
MagickGetFilename.restype = STRING
MagickGetFilename.argtypes = [POINTER(MagickWand)]
MagickGetFormat = _lib.MagickGetFormat
MagickGetFormat.restype = STRING
MagickGetFormat.argtypes = [POINTER(MagickWand)]
MagickGetHomeURL = _lib.MagickGetHomeURL
MagickGetHomeURL.restype = STRING
MagickGetHomeURL.argtypes = []
MagickGetOption = _lib.MagickGetOption
MagickGetOption.restype = STRING
MagickGetOption.argtypes = [POINTER(MagickWand), STRING]
MagickQueryConfigureOption = _lib.MagickQueryConfigureOption
MagickQueryConfigureOption.restype = STRING
MagickQueryConfigureOption.argtypes = [STRING]
MagickQueryConfigureOptions = _lib.MagickQueryConfigureOptions
MagickQueryConfigureOptions.restype = POINTER(STRING)
MagickQueryConfigureOptions.argtypes = [STRING, POINTER(c_ulong)]
MagickQueryFonts = _lib.MagickQueryFonts
MagickQueryFonts.restype = POINTER(STRING)
MagickQueryFonts.argtypes = [STRING, POINTER(c_ulong)]
MagickQueryFormats = _lib.MagickQueryFormats
MagickQueryFormats.restype = POINTER(STRING)
MagickQueryFormats.argtypes = [STRING, POINTER(c_ulong)]
MagickGetCompression = _lib.MagickGetCompression
MagickGetCompression.restype = CompressionType
MagickGetCompression.argtypes = [POINTER(MagickWand)]
MagickGetCopyright = _lib.MagickGetCopyright
MagickGetCopyright.restype = STRING
MagickGetCopyright.argtypes = []
MagickGetPackageName = _lib.MagickGetPackageName
MagickGetPackageName.restype = STRING
MagickGetPackageName.argtypes = []
MagickGetQuantumDepth = _lib.MagickGetQuantumDepth
MagickGetQuantumDepth.restype = STRING
MagickGetQuantumDepth.argtypes = [POINTER(c_ulong)]
MagickGetQuantumRange = _lib.MagickGetQuantumRange
MagickGetQuantumRange.restype = STRING
MagickGetQuantumRange.argtypes = [POINTER(c_ulong)]
MagickGetReleaseDate = _lib.MagickGetReleaseDate
MagickGetReleaseDate.restype = STRING
MagickGetReleaseDate.argtypes = []
MagickGetVersion = _lib.MagickGetVersion
MagickGetVersion.restype = STRING
MagickGetVersion.argtypes = [POINTER(c_ulong)]
MagickGetSamplingFactors = _lib.MagickGetSamplingFactors
MagickGetSamplingFactors.restype = POINTER(c_double)
MagickGetSamplingFactors.argtypes = [POINTER(MagickWand), POINTER(c_ulong)]
MagickQueryFontMetrics = _lib.MagickQueryFontMetrics
MagickQueryFontMetrics.restype = POINTER(c_double)
MagickQueryFontMetrics.argtypes = [POINTER(MagickWand), POINTER(DrawingWand), STRING]
MagickQueryMultilineFontMetrics = _lib.MagickQueryMultilineFontMetrics
MagickQueryMultilineFontMetrics.restype = POINTER(c_double)
MagickQueryMultilineFontMetrics.argtypes = [POINTER(MagickWand), POINTER(DrawingWand), STRING]
MagickGetInterlaceScheme = _lib.MagickGetInterlaceScheme
MagickGetInterlaceScheme.restype = InterlaceType
MagickGetInterlaceScheme.argtypes = [POINTER(MagickWand)]
MagickGetPage = _lib.MagickGetPage
MagickGetPage.restype = MagickBooleanType
MagickGetPage.argtypes = [POINTER(MagickWand), POINTER(c_ulong), POINTER(c_ulong), POINTER(c_long), POINTER(c_long)]
MagickGetSize = _lib.MagickGetSize
MagickGetSize.restype = MagickBooleanType
MagickGetSize.argtypes = [POINTER(MagickWand), POINTER(c_ulong), POINTER(c_ulong)]
MagickProfileImage = _lib.MagickProfileImage
MagickProfileImage.restype = MagickBooleanType
MagickProfileImage.argtypes = [POINTER(MagickWand), STRING, c_void_p, size_t]
MagickSetBackgroundColor = _lib.MagickSetBackgroundColor
MagickSetBackgroundColor.restype = MagickBooleanType
MagickSetBackgroundColor.argtypes = [POINTER(MagickWand), POINTER(PixelWand)]
MagickSetCompression = _lib.MagickSetCompression
MagickSetCompression.restype = MagickBooleanType
MagickSetCompression.argtypes = [POINTER(MagickWand), CompressionType]
MagickSetCompressionQuality = _lib.MagickSetCompressionQuality
MagickSetCompressionQuality.restype = MagickBooleanType
MagickSetCompressionQuality.argtypes = [POINTER(MagickWand), c_ulong]
MagickSetFilename = _lib.MagickSetFilename
MagickSetFilename.restype = MagickBooleanType
MagickSetFilename.argtypes = [POINTER(MagickWand), STRING]
MagickSetFormat = _lib.MagickSetFormat
MagickSetFormat.restype = MagickBooleanType
MagickSetFormat.argtypes = [POINTER(MagickWand), STRING]
MagickSetImageProfile = _lib.MagickSetImageProfile
MagickSetImageProfile.restype = MagickBooleanType
MagickSetImageProfile.argtypes = [POINTER(MagickWand), STRING, c_void_p, size_t]
MagickSetInterlaceScheme = _lib.MagickSetInterlaceScheme
MagickSetInterlaceScheme.restype = MagickBooleanType
MagickSetInterlaceScheme.argtypes = [POINTER(MagickWand), InterlaceType]
MagickSetOption = _lib.MagickSetOption
MagickSetOption.restype = MagickBooleanType
MagickSetOption.argtypes = [POINTER(MagickWand), STRING, STRING]
MagickSetPage = _lib.MagickSetPage
MagickSetPage.restype = MagickBooleanType
MagickSetPage.argtypes = [POINTER(MagickWand), c_ulong, c_ulong, c_long, c_long]
MagickSetPassphrase = _lib.MagickSetPassphrase
MagickSetPassphrase.restype = MagickBooleanType
MagickSetPassphrase.argtypes = [POINTER(MagickWand), STRING]
MagickSetResolution = _lib.MagickSetResolution
MagickSetResolution.restype = MagickBooleanType
MagickSetResolution.argtypes = [POINTER(MagickWand), c_double, c_double]
MagickSetResourceLimit = _lib.MagickSetResourceLimit
MagickSetResourceLimit.restype = MagickBooleanType
MagickSetResourceLimit.argtypes = [ResourceType, MagickSizeType]
MagickSetSamplingFactors = _lib.MagickSetSamplingFactors
MagickSetSamplingFactors.restype = MagickBooleanType
MagickSetSamplingFactors.argtypes = [POINTER(MagickWand), c_ulong, POINTER(c_double)]
MagickSetSize = _lib.MagickSetSize
MagickSetSize.restype = MagickBooleanType
MagickSetSize.argtypes = [POINTER(MagickWand), c_ulong, c_ulong]
MagickSetType = _lib.MagickSetType
MagickSetType.restype = MagickBooleanType
MagickSetType.argtypes = [POINTER(MagickWand), ImageType]
MagickSetProgressMonitor = _lib.MagickSetProgressMonitor
MagickSetProgressMonitor.restype = MagickProgressMonitor
MagickSetProgressMonitor.argtypes = [POINTER(MagickWand), MagickProgressMonitor, c_void_p]
MagickGetImageProfile = _lib.MagickGetImageProfile
MagickGetImageProfile.restype = POINTER(c_ubyte)
MagickGetImageProfile.argtypes = [POINTER(MagickWand), STRING, POINTER(c_size_t)]
MagickRemoveImageProfile = _lib.MagickRemoveImageProfile
MagickRemoveImageProfile.restype = POINTER(c_ubyte)
MagickRemoveImageProfile.argtypes = [POINTER(MagickWand), STRING, POINTER(size_t)]
MagickGetImageProperty = _lib.MagickGetImageProperty
MagickGetImageProperty.restype = STRING
MagickGetImageProperty.argtypes = [POINTER(MagickWand), STRING]
MagickSetImageProperty = _lib.MagickSetImageProperty
MagickSetImageProperty.restype = MagickBooleanType
MagickSetImageProperty.argtypes = [POINTER(MagickWand), STRING, STRING]
MagickGetCompressionQuality = _lib.MagickGetCompressionQuality
MagickGetCompressionQuality.restype = c_ulong
MagickGetCompressionQuality.argtypes = [POINTER(MagickWand)]
MagickGetResource = _lib.MagickGetResource
MagickGetResource.restype = c_ulong
MagickGetResource.argtypes = [ResourceType]
MagickGetResourceLimit = _lib.MagickGetResourceLimit
MagickGetResourceLimit.restype = c_ulong
MagickGetResourceLimit.argtypes = [ResourceType]

_PixelIterator._fields_ = [
]

PixelGetAlpha = _lib.PixelGetAlpha
PixelGetAlpha.restype = c_double
PixelGetAlpha.argtypes = [POINTER(PixelWand)]


IsPixelWandSimilar = _lib.IsPixelWandSimilar
IsPixelWandSimilar.restype = MagickBooleanType
IsPixelWandSimilar.argtypes = [POINTER(PixelWand), POINTER(PixelWand), c_double]

PixelSetColor = _lib.PixelSetColor
PixelSetColor.restype = MagickBooleanType
PixelSetColor.argtypes = [POINTER(PixelWand), STRING]
PixelSetOpacity = _lib.PixelSetOpacity
PixelSetOpacity.restype = MagickBooleanType
PixelSetOpacity.argtypes = [POINTER(PixelWand), c_double]
PixelSetAlpha = _lib.PixelSetAlpha
PixelSetAlpha.restype = MagickBooleanType
PixelSetAlpha.argtypes = [POINTER(PixelWand), c_double]
DestroyPixelWand = _lib.DestroyPixelWand
DestroyPixelWand.restype = POINTER(PixelWand)
DestroyPixelWand.argtypes = [POINTER(PixelWand)]

NewPixelWand = _lib.NewPixelWand
NewPixelWand.restype = POINTER(PixelWand)
NewPixelWand.argtypes = []

